          Table of Contents for UUPlus Utilities Configuration Files

                                   Section 5
                                   1/10/1995


UUPLUS CONFIGURATION FILES ...................... 5.0
         Directory Structure .................... 5.0.1
         File List by Directory ................. 5.0.2


UUPLUS.CFG
         Sample UUPLUS.CFG file ................. 5.1

     System Information
         Runmode ................................ 5.1.1
         Sysname ................................ 5.1.2
         Logname ................................ 5.1.3
         Username ............................... 5.1.4
         Fullname ............................... 5.1.5
         Smarthost .............................. 5.1.6    

     Operational Configuration
         Debuglevel ............................. 5.1.7
         Mailgrade .............................. 5.1.8
         Newsgrade .............................. 5.1.9
         Maxlimit ............................... 5.1.10
         Attribution ............................ 5.1.11
         Yousaid ................................ 5.1.12
         Organization ........................... 5.1.13

     Directory Information
          Home .................................. 5.1.14
          Spool ................................. 5.1.15
          Libdir ................................ 5.1.16
          Public ................................ 5.1.18
          News .................................. 5.1.19
          Logfile ............................... 5.1.20
          Ramdisk ............................... 5.1.21

     Feature Information
          Editor ................................ 5.1.22
          Visual ................................ 5.1.23

     Optional Fields
          Timezone .............................. 5.1.24
          Timeformat ............................ 5.1.25
          Serveralias ........................... 5.1.26


SYSTEMS File .................................... 5.2
    Sample SYSTEMS file ......................... 5.2.1
         The Chat Script ........................ 5.2.2
               System ........................... 5.2.2.1
               Time (ANY) ....................... 5.2.2.2
               Dialer (HAYES). .................. 5.2.2.3
               Baud ............................. 5.2.2.4
               Dial String ...................... 5.2.2.5
               Send / Expect .  ................. 5.2.2.6
               Escape Codes ..................... 5.2.2.7
               Login............................. 5.2.2.8
               Password ......................... 5.2.2.9


     SYSTEMS CONFIGURATION COMMANDS
         Ulimit  ................................ 5.2.3
         G_Window ............................... 5.2.4
         G_Packet ............................... 5.2.5
         Retries ................................ 5.2.6
         Retrytimes ............................. 5.2.7
         Gradechar .............................. 5.2.8
         Protocols .............................. 5.2.9
    

HAYES.MDM File .................................. 5.3
     Sample MODEM Configuration file ............ 5.3.1
          Port .................................. 5.3.2
          Membase ............................... 5.3.3
          IRQ ................................... 5.3.4
          16550Trigger .......................... 5.3.5
          Diskbuffer ............................ 5.3.6
          Portspeed ............................. 5.3.7
          Hardwareflow .......................... 5.3.8
          Driver ................................ 5.3.9
          Dialer ................................ 5.3.10
          TCD ................................... 5.3.11
          TLogin ................................ 5.3.12
          TData ................................. 5.3.13
          Init .................................. 5.3.14
          Shutdown .............................. 5.3.15
          Maxerror .............................. 5.3.16


MAILRC .......................................... 5.4
          Autosig ............................... 5.4.1
          Askcc ................................. 5.4.2
          Dot ................................... 5.4.3
          Ignoreeof ............................. 5.4.4
          Nosave ................................ 5.4.5
          Record ................................ 5.4.6
          Metoo ................................. 5.4.7
          Escape Char ........................... 5.4.8
          Screen Len ............................ 5.4.9
          Mail Prompt ........................... 5.4.10


ALIASES Files ................................... 5.5
          Network Aliasing ...................... 5.5.1


SIG File ........................................ 5.6


BATCHER.CFG File ................................ 5.7
         Site ................................... 5.7.1
         Size ................................... 5.7.2
         Queue .................................. 5.7.3
         Muncher ................................ 5.7.4
         Sender ................................. 5.7.5


SYS File ........................................ 5.8
         Site ................................... 5.8.1
         Newsgroups ............................. 5.8.2
         Flags .................................. 5.8.3
         Command ................................ 5.8.4


ACTIVE File ..................................... 5.9
         Group .................................. 5.9.1
         LSEQ ................................... 5.9.2
         HSEQ ................................... 5.9.3
         Post ................................... 5.9.4


NEWSRC File ..................................... 5.10


EXPLIST File .................................... 5.11
         Newsgroup .............................. 5.11.1
         Type ................................... 5.11.2
         Days ................................... 5.11.3
         Archdir ................................ 5.11.4


HEADERS File .................................... 5.12
         Extended Headers ....................... 5.12.1
         Header Directives ...................... 5.12.2
         Example HEADER File .................... 5.12.3


MODRECDG File ................................... 5.13


RECORDIN File ................................... 5.14


*******************************************************************
5.0.1      UUPLUS DIRECTORY STRUCTURE

    Note that the "user" directory(s) will be the same as USERNAME set by 
    the environment variable or in the UUPLUS.CFG file.  The directory 
    "smarthost" is the name of your service provider, if you call more than 
    one system, there will be more than one.  Configuration files marked 
    with a (*) are required for the system to run.

    \-UUPLUS---\-HOME----\-user ..................... (sig, newsrc, mailrc,
               |         |                             personal aliases file)
               |         \-user2
               |
               \-SPOOL---\-MAIL ..................... (incoming mail)
               |         |
               |         \-UUCP---\-TMP ............. (mail and news 
               |                  |                        temp files)
               |                  \-PUBLIC .......... (not used at this time)
               |                  |
               |                  \-smarthost---\-BAD
               |                                |
               |                                \-D . (outgoing mail)
               |                                |
               |                                \-N . (outgoing batched news)
               |
               \-LIB-----\-NEWS ..................... (news config files)
               |         |
               |         \-UUCP ..................... (the systems file)
               |         |
               |         \-MODEM .................... (the *.MDM files)
               |
               \-NEWS----\-OUTGOING ................. (command file for 
                         |                             batching outgoing news)
                         \-COMP---\-newsgroups . .... (news directories)
                         |
                         \-ALT----\-newsgroups



5.0.2    FILE LIST by DIRECTORY

    [d]:\UUPLUS\
              ACTMAKE.EXE     BATCHER.EXE     COMP.EXE     DECOMP.EXE
              EXPIRE.EXE      FIXACTIV.EXE    FROM.EXE     MAIL.EXE
              POSTNEWS.EXE    READNEWS.EXE    RMAIL.EXE    UUCICO.EXE
              UUCP.EXE        UULOG.EXE       UUQ.EXE      UUSNAP.EXE
              UUXQT.EXE       UUPLUS.CFG*

              Note:  Not all of the .EXE files are included in every 
              distribution package of UUPlus Utilities.  If your version of 
              UUPlus Utilities came with a BBS, only the ones used by the 
              BBS were shipped.

    [d]:\UUPLUS\HOME\USER\  SIG,  NEWSRC,  MAILRC,  ALIASES

    [d]:\UUPLUS\SPOOL\MAIL\  USER  (The incoming mail file of the user)

    [d]:\UUPLUS\SPOOL\UUCP\  LOGFILE

    [d]:\UUPLUS\LIB\  ALIASES*,  MAILRC*

    [d]:\UUPLUS\LIB\MODEM\  HAYES.MDM*

    [d]:\UUPLUS\LIB\NEWS\  ACTIVE*,  BATCHER.CFG*,  DIST*,  EXPLIST*,
                           HEADERS*,  RECORDIN,  SYS*

    [d]:\UUPLUS\LIB\UUCP\  SYSTEMS*


    Temporary Files:

         All incoming mail and news is placed in \SPOOL\UUCP\SMARTHOST by 
         UUCICO for processing by UUXQT.  When UUXQT is run, it first reads 
         the *.X?? files, process the corresponding *.D?? file, places the 
         processed file in the proper directory, and then deletes the 
         original .X and .D files when it is finished.

         All outgoing files are placed in SPOOL\UUCP\SMARTHOST\D where D 
         corresponds to the grade of the mail or news.  Mail is usually 
         grade D, but if you have MAILGRADE set to something other than D, 
         the directory will correspond to that grade.  The same is true 
         with news.


****************************************************************
5.1      UUPLUS.CFG          [BASEDIR] \ UUPLUS.CFG

    This is the main configuration file.  It controls execution of the 
    UUPlus Utilities, contains the directory list and user information.  
    Lines consist of a control variable and a value, separated by white 
    space (space or tab).  Blank lines are ignored.

    Note:  The order of placement of the directives in the UUPLUS.CFG file 
    is not important.

                            SAMPLE UUPLUS.CFG file.

    # Configuration file for UUPlus Utilities 1.52
    #
    # Lines beginning with "#" are comments
    # Blank lines are ignored
    # Format:
    # option       value
    #
    # This file must be modified to meet your specific # system configuration
    #
    # Runmode. DO NOT REMOVE THIS DIRECTIVE, as it controls runtime
information
    runmode        UTILS

    # System Information
    sysname        firesta.com
    logname        firesta
    username       chief
    fullname       Chief Firefighter
    smarthost      nextsite

    # Operational Configuration
    debuglevel     3
    mailgrade      D
    newsgrade      N
    maxlimit       disabled
    attribution    A wise man once said...
    yousaid        You recently wrote...
    organization   Fire Station No. 7

    # Directory Information
    home           c:\uuplus\home
    spool          c:\uuplus\spool
    libdir         c:\uuplus\lib
    pubdir         c:\uuplus\spool\uucp\public
    news           c:\uuplus\news
    logfile        c:\uuplus\spool\uucp\logfile
    #ramdisk       (none)

    # Feature Information
    editor         visual
    visual         c:\dos\edit.com


5.1.1     RUNMODE 

    Runmode is used internally by UUPlus Utilities to display the proper 
    copyright information.  Do not remove or change this directive, as it 
    gives credit where credit is due.  The default is shown.

         runmode   UTILS



                              SYSTEM  INFORMATION

5.1.2    SYSNAME

    This is the Fully-Qualified Domain Name (FQDN), or SYSNAME of your 
    site.  Your feed site administrator should be able to tell you what 
    your FQDN is, or help you pick one, since they are the ones who are 
    responsible for forwarding your mail and news to you.  If you do not 
    have a domain name, the psuedo-domain .UUCP may be used, though it is 
    discouraged, as most mailers will not understand it.  It is highly 
    recommended that you obtain a domain name.  The .US domain set is free 
    for the asking.

         sysname   firesta.com
         sysname   firesta.UUCP


5.1.3    LOGNAME

    This is the standard UUCP SITE name or LOG name, the name that other 
    machines recognize your machine by.  Usually it is the first part of 
    your SYSNAME (FQDN), that is, the part before the first dot, although 
    it may be different.  For example, if your FQDN is "mycmpny.com", your 
    site name is more than likely "mycmpny".  INSTALL prompts you with your 
    site name based on your sysname.  Your site name should not be more 
    than 7 characters to insure compatibility with BNU UUCP.  8 characters 
    are allowed with other UUCPs.

         logname   firesta


5.1.4    USERNAME

    This is the default USER name.  This determines which mailbox to use, 
    as well as which return paths are used by mail and news.  Unless 
    overrided with the environment variable USERNAME (see Environment 
    Variables), this one will be used.  It is recommended that whomever 
    administrates your site put his or her USERNAME in here.  If you're the 
    only one using your site, then you're set.  USERNAME is analogous to an 
    account name on a UNIX machine.  It must be no more than 8 characters 
    long.

         username  chief

    Your Internet address would then be:  chief@firesta.com


5.1.5    FULLNAME

    This is the full name of the user as it should appear in mail and news 
    headers to identify a user.  You can put your nickname in here, or your 
    real name, or whatever you wish.  Note that the value of the 
    environment variable FULLNAME will override this setting.  (See 
    Environment Variables)

         fullname  Chief Firefighter

    The 'From:' line in MAIL would then look like:

         From: chief@firestation.org (Chief Firefighter)


5.1.6    SMARTHOST

    This is a valid UUCP bang-path to your SMARTHOST at the site which 
    handles resolution of your email.  This is almost always your HOST 
    provider.  Do not use their FQDN, rather, use their UUCP name as it 
    appears in the [LIBDIR]/UUCP/SYSTEMS file.  Your service provider will 
    provide this information for you if you are not sure what it is.

         smarthost nextsite

    Note:  At this time, UUPlus Utilities does not support domainized 
    mailing by itself.  If a mail path is generated that UUPlus Utilities 
    does not understand, it will send the message off to this site, hoping 
    it can make sense of it.  Be sure that the first name in the SMARTHOST 
    field is a system to which you connect directly, and that it is 
    mentioned in your SYSTEMS file.  In most cases, your smarthost will be 
    the sole site that you talk to.

    In the case where the site you are talking to cannot act as a 
    SMARTHOST, you can route it through them.

         smarthost nextsite!provider

    In the above example, mail to "mayor@ourcity.gov" would be mailed as 
    "nextsite!provider!mayor@ourcity.gov", parsing from left to right.  
    (That is, it would be sent to "nextsite", then to "provider" who would 
    be expected to be able to get it to user "mayor" at "ourcity.gov").



                           OPERATIONAL CONFIGURATION

5.1.7    DEBUGLEVEL

    The level of debugging UUCICO should use if not included on the command 
    line with the -x option.  The default is 3 if not specified.

         debuglevel 3


5.1.8    MAILGRADE

    The grade at which to queue Mail.  Grade determines the priority which 
    mail and news files are processed.  Valid values are A - Z.  "A" is 
    processed first, "Z" last.  The default is D.

         mailgrade D


5.1.9    NEWSGRADE

    The grade at which to queue News batches.  Most systems will want Mail 
    set at a higher grade than News.  The default is N.

         newsgrade  N


5.1.10   MAXLIMIT

    The maximum accepted incoming file size.  If the remote UUCP 
    understands file size limits, any file of this size or larger will be 
    rejected.  (ULIMIT, in the SYSTEMS file, is used to limit the total 
    amount of bytes received in a given session.)  The default is disabled. 

         maxlimit  1000000
         maxlimit  disabled


5.1.11   ATTRIBUTION

    This field allows you to create the format for the "attribution" line 
    for NEWS messages.  This line will be placed at the top of all outgoing 
    news articles which are follow-ups of other articles.  This line comes 
    before quoted text.

         attribution   A Wise Man Once Said...


5.1.12   YOUSAID

    This field allows you to create the format for the "yousaid" line in 
    MAIL messages.  This line will be placed at the top of all outgoing 
    mail which is generated as a reply to another mail message.  This line 
    comes before quoted text.

         yousaid  In Your Last Mail, You Said...


5.1.13   ORGANIZATION

    This field is the organization to which your site belongs.  It is added 
    to the HEADER any outgoing USENET News postings.

         organization  Fire Station No. 7



                             DIRECTORY INFORMATION

    The base directory for UUPlus Utilities is the one pointed to by the 
    SET variable in the AUTOEXEC.BAT file, usually [drive]:\UUPLUS.  The 
    UUPLUS.CFG file resides in this directory, as do all the .EXE files.  
    You can change this setting to fit your requirements, though it is 
    recommended that you retain :\UUPLUS as your base directory if you are 
    not well versed in DOS or UUCP.  The base directory is identified with 
    the SET variable in the AUTOEXEC.BAT file, not with a control variable 
    in the UUPLUS. CFG file.  The following are the path statements in the 
    UUPLUS.CFG file.


5.1.14   HOME

    This is the directory under which each user will have a home directory 
    for storing his or her ALIASES, SIG, MAILRC, and NEWSRC files, as well 
    as any system generated files specific to the user.  Inside the home 
    directory are found directories named after each user on the system.

         home  c:\uuplus\home

    Do not create user home directories in \SPOOL\MAIL.  Doing so will 
    prohibit mail from being delivered.  Incoming mail is initially stored 
    in files named after the recipient, such as: \SPOOL\MAIL\CHIEF.  
    Creating a directory with the same name will prevent mail from being 
    saved.


5.1.15   SPOOL

    This is the directory under which all incoming and outgoing files are 
    kept.  Inside of spool is the mail holding directory, SPOOL \MAIL, and 
    all UUCP queue files for the various systems.  It is recommended that 
    this be placed on your fastest disk (if you have more than one) and 
    that there be enough space available for it to grow during transfers.  
    The amount of room needed is dependent on how much data you intend to 
    transfer.

         spool  c:\uuplus\spool


5.1.16   LIBDIR

    This is the directory under which UUCP and USENET News keep their 
    configuration and operation files.

         libdir  c:\uuplus\lib


5.1.18   PUBLIC

    This is the directory for public file placement.  This directory holds 
    all files that are neither mail nor news.  It is currently unused but 
    is reserved for future expansion. 

         pubdir  c:\uuplus\spool\uucp\public


5.1.19   NEWS

    This is the base directory for the USENET News directories.  All 
    newsgroup storage areas are based off of this path.  The amount of 
    space needed for this directory is determined solely by the amount of 
    news you expect to keep.  News can grow quite large, so keep an eye on 
    this one.  The installer will also create [NEWS] \OUTGOING  for 
    outgoing batch files.

         news  c:\uuplus\news


5.1.20   LOGFILE

    This is the name and location of the UUCP log file.  Note that this 
    field contains a complete file name, not just a directory as in other 
    fields.  UUPlus Utilities generates log files that can be more detailed 
    than UNIX(tm) log files, but can provide useful information for 
    debugging purposes and feed testing.  You will want to watch the size 
    of this file and prune it occasionally.   You can use an ASCII text 
    editor such as the DOS EDIT program to do this.

         logfile  c:\uuplus\spool\uucp\logfile


5.1.21   RAMDISK

    This optional field contains the drive letter of any ramdisk you may be 
    using.  If supplied, all temporary files will be stored on the ramdisk 
    and will speed up performance considerably.  If there is no ramdisk, 
    temporary files are kept in [SPOOL]/UUCP/TMP, which will be 
    automatically created if needed.  Be sure that the size of your RAM 
    disk is large enough to handle all temporary files, otherwise they may 
    be truncated.

         ramdisk  e



                              FEATURE INFORMATION

5.1.22   EDITOR

    UUPlus Utilities has an internal line editor (line), or it allows you 
    to specify your own (visual).  If you specify the LINE editor, you may 
    still enter the VISUAL editor with the '~v' escape code from within the 
    line editor.

         editor  visual

    NOTE:  The line editor is included to maintain compatibility with 
    standard UNIX mailers such as mail and mailx.  It has limited 
    capability, so most users will want to use a visual editor.  See the 
    next section for more information on the visual editor.


5.1.23   VISUAL

    This is the full path to the editor you wish to use to compose your 
    mail and news postings.  This program will be called if the EDITOR 
    field is set to "visual," or you shell to a visual editor from within 
    the line editor.  

    The editor must be able to accept the name of the file to be edited as 
    the first and only argument, and not change the name of the final 
    edited file.  The editor must also be able to save in ASCII format.  On 
    systems with low memory you will want to use an editor that doesn't 
    require more than you have available.

         visual  c:\dos\edit.com



                                OPTIONAL FIELDS

    The following is a list of the optional fields in the UUPLUS.CFG file.  
    It is recommended that caution be exercised in using these variables, as 
    using them incorrectly may result in lost mail and news.  You are 
    forewarned.


5.1.24   TIMEZONE

    The timezone directive allows the TZ variable set in the autoexec.bat 
    file to be overwritten with the literal string following "timezone".  
    This is included for systems that require a time zone stamp that 
    references an offset to GMT.  For example, if you live in Athens, 
    Greece, your time zone stamp should be "+0200".  Include the line:

         timezone  +0200

    at the end of the UUPLUS.CFG file.  The date/time stamp will be 
    appended with "+0200".  The following lines would also be acceptable 
    for their particular geographical location:

         timezone  GMT +0200
         timezone  0000 (GMT)
         timezone  -0800 (PST)

    Care should be given with this variable, as any string following the 
    timezone variable will be appended to the date/time stamp, and NOT 
    CHECKED for compliance with RFC-822 standards.  If the timezone 
    variable is included, but is not followed with a string, no time zone 
    will be stamped in the date/time field in outgoing mail or news.

    For  United States time zones, it is recommended to set the 
    time zone with the TZ variable in the autoexec.bat file, as the TZ 
    variable will automatically change from Standard time to Daylight 
    Savings time.  Using the timezone directive does not have this 
    feature.  See section 3.1.2 for information on the TZ environment 
    variable.

    The RFC-822 specification for date and time stamps is included in 
    section 10 of this manual.


5.1.25   TIMEFORMAT 

    The TIMEFORMAT directive is included to override the default date/time 
    stamp set internally in UUPlus Utilities.  This directive allows the 
    user to format the date/time stamp to suit their needs for the country 
    they are in.

    Great care should be used when using this directive as the date/time 
    stamp can be formatted so as to not be accepted by systems "down 
    stream" from your system, resulting in lost mail and news.  If 
    the TIMEFORMAT directive is included in the UUPLUS.CFG file with no 
    formatting text following it, no date/time stamp will placed in mail 
    being processed.  USE THIS DIRECTIVE CAREFULLY AND TEST THOROUGHLY!

    The TIMEFORMAT directive can be included at the end of the UUPLUS.CFG 
    file in the following format:

         timeformat   specifer-list

    where the "specifer-list" is based on the following list of allowed 
    format specifiers for the TIMEFORMAT directive.

    ----------------------------------------------------------------------
      Specifier    Substitutes
    ----------------------------------------------------------------------
         %%        Character %
         %a        Abbreviated weekday name
         %A        Full weekday name
         %b        Abbreviated month name
         %B        Full month name
         %c        Date and time
         %d        Two-digit day of the month (01 to 31)
         %H        Two-digit hour (00 to 23)
         %I        Two-digit hour (01 to 12)
         %j        Three-digit day of the year (001 to 366)
         %m        Two-digit month as a decimal number (1 - 12)
         %M        Two-digit minute (00 to 59)
         %p        AM or PM
         %S        Two-digit second (00 to 59)
         %U        Two-digit week number where Sunday is the first day of
                        the week (00 to 53)
         %w        Weekday where 0 is Sunday (0 to 6)
         %W        Two-digit week number where Monday is the first day of
                        the week (00 to 53)
         %x        Date
         %X        Time
         %y        Two-digit year without century (00 to 99)
         %Y        Year with century
         %Z        Time zone name, or no characters is no time zone.  This
                        is controlled by the TZ variable in the autoexec.bat
                        file.
    ----------------------------------------------------------------------

Formatting TIMEFORMAT


    To format the date/time as:  "Wed, Dec 21, 1994 12:16:29"  the 
    timeformat line would like:

         timeformat  %a, %b %d, %Y %H:%M:%S

    This is the default internal setting in UUPlus.



         The line:
                        timeformat  %A, %B %d, %Y %H.%M.%S
         will produce:
                        Wednesday, December 21, 1994 12.16.22

         Note the use of the periods (.) in the time stamp.  This may 
    create a problem with sending international e-mail, it is recommended 
    that a colin (:) be used.



    For use in England, the TIMEFORMAT line could look like:

              timeformat  %a, %d %b, %Y %H:%M:%S

         and would produce:

              Thu, 22 Dec, 1994 10:37:47


Testing TIMEFORAMT


    To test, you can send mail to yourself.  Invoke MAIL as:

         mail username

    where "username" is your username in the UUPLUS.CFG file.  Compose a 
    short piece of mail and then invoke MAIL to read.  Observe the date 
    stamps to make sure they are correct.


    Note:  It is important to keep the date/time stamp compliant to RFC-822 
    requirements.  A "personalized" format may not be allowed by your host 
    provider or by other systems that process your mail and news.



    The RFC-822 specification for date and time stamps is included in 
    section 10 of this manual.


5.1.26   SERVERALIAS

    This field allows a remote machine to store files with server-dependent 
    drive specifications.  This is used by BATCHER.EXE to correctly access 
    news articles for batching.  For example, if a network is running such 
    that the remote machine references the server's C: drive as F:, this 
    field allows BATCHER to run using the correct reference (C:).

    In this example, any references in a batch file in [NEWS]/OUTGOING for 
    any drive letter will be changed to C. This unconditional mapping will 
    allow the server to correctly access the articles.

         serveralias  c


*******************************************************************
5.2      SYSTEMS File        [LIBDIR] \ UUCP \ SYSTEMS


                   SYSTEMS File Format for UUPlus Utilities

    The SYSTEMS file controls how UUPlus Utilities logs into the remote 
    system.  Think of it as a basic login script processor.


5.2.1    Sample SYSTEMS file

    # systems file - UUPlus Utilities 1.52
    #
    # This file controls how uucico.exe logs into the remote machine. Here are
    # a few example systems scripts. Probably the hardest part of setting up a
    # mail and news feed is getting this to work # correctly. Have patience
and
    # be observant.
    #
    # Lines beginning with "#" are comments. Blank lines # are ignored.
    #
    # ESCAPE CODES SUPPORTED:
    #
    # \b      - send break
    # \r      - send return
    # \n      - send newline
    # \t      - send tab
    # \d      - flush line, delay 1 second
    # \s      - send space
    # \c      - do NOT send a return at the end of this line (default is to do
    #                                                                      
so)
    # \\      - send a backslash
    #
    # EXPECT/SEND/EXPECT
    #
    # expect strings may have conditional retry in the # format
    #
    #   expect1-send-expect2
    #
    # whereas if [expect1] isn't seen in the time specified by the "timeout"
    # variable in the .CFG file, the text [send] will be sent, and [expect]
    # will be scanned for.
    #
    # a string of the format
    #
    #   expect1--expect2
    #
    # will cause a single return to be sent should [expect1] not be seen

    nextsite Any Hayes 9600 ATDT555-1212 "" <CR> ogin: yourlogin
                                                        ssword: yourpassword

    # Window request level for g protocol. Default is 7. # Valid values are
    # from 1 to 7
    #
    configure   g_window     7
    #
    # Packet request level for g protocol. Default is 64 Valid values are from
    # 64 bytes, to 4096 in powers of 2. NOTE that some UNIX systems will
behave
    # unpredictably if you send a packet request other # than 64.
    # Experimentation is the best way to go.
    #
    configure   g_packet     64
    #
    configure   ulimit       disable
    #
    # gradechar may be either 'p' or 'v' depending on # host requirements
    #
    configure   gradechar    p
    #
    # 3 retries at 60, 120, and 180 second delays
    #
    configure   retries      3
    configure   retrytimes   60,120,180



                              CHAT SCRIPT INFORMATION

5.2.2    The CHAT SCRIPT

    Here is a sample chat script entry.  Note that this is one complete 
    line.  Each entry is explained below.

         nextsite Any Hayes 9600 ATDT555-1212 "" <CR> ogin: YourLogin
                                                    ssword: YourPassword


5.2.2.1  NEXTSITE  (system)

    The system we are calling.  This should be the same as the entries in 
    the BATCHER.CFG and SYS files.  If a system does not appear here, you 
    cannot send mail, news or files directly to it.


5.2.2.2  ANY  (time)

    The time you may call.  Currently, time to call is not implemented, as 
    all polls are done manually from a DOS environment.


5.2.2.3  HAYES  (dialer)

    The dialer type.  UUCICO will look for a file in [LIBDIR]\MODEM with 
    the name of the dialer, and in *.MDM for information about how to 
    handle this dialer.


5.2.2.4  9600  (baud)

    The baud rate at which to set the communications port for the actual 
    communication to the remote site.


5.2.2.5  ATDT5551212  (dial string)

    The string to dial. 'ATDT' is a typical Hayes(tm) dialing prefix which 
    stands for ATtention Dial Tone,  followed by the data phone number of 
    your service provider (not the one for directory assistance).  For a 
    direct connection, you may substitute this for anything needed to wake 
    the connection up, otherwise, put in a return ("\r", see below for more 
    information).


5.2.2.6   "" <CR> ogin: YourLogin ssword: YourPassword  (send / expect)

    The rest of the SYSTEMS line is a send/expect pair script, that is, 
    alternating strings to expect from the remote site, and what to send 
    when that string is received.  In this instance, "" means expect 
    nothing, and send a carriage return sequence.  The <CR> is unique to 
    UUPlus Utilities, it directs UUCICO to send a return once per second 
    for 10 seconds until something is received from the remote site. For 
    some sites a single '\r' works best.

         Expect   Send    Expect   Send        Expect    Send
         ------   ----    ------   ---------   --------  ------------
         ""       <CR>    ogin:    YourLogin   ssword    YourPassword
         ------   ----    ------   ---------   --------  ------------
         Nothing  <CR>'s  Login:   Acct.Name   Password  Password

    NOTE:  'Login:' and 'Password:' usually have the first characters 
    missing to allow for characters dropped and to still login properly.

    UUCP logins are, by convention, your SITE NAME, preceded by a capital 'U'.


5.2.2.7  ESCAPE CODES

    The systems send/expect script processor also understands some basic 
    escape codes for non-printing characters:

         ""   Nothing
         \b   Break
         \r   Return
         \n   Newline
         \t   Tab
         \d   Flush line, delay 1 second
         \s   Space
         \c   Don't send a return at the end of this line (default is to do
so)
         \\   A backslash
        <CR>  Send a return once per second for 10 seconds until something is
                   received from the remote site.


5.2.2.8  REMOTE HOST LOGIN

    This is the string that UUCICO sends to your host to identify your 
    system.

         ogin: YourLogin  


5.2.2.9  REMOTE HOST PASSWORD

    This is the pass word that your service provider has given you.

         ssword: YourPassword 

    The above SYSTEMS file contains more complex examples for logging on 
    through network and terminal controllers typical of some Internet 
    service providers and large sites such as universities.  Most UNIX 
    systems with modems directly connected can use the simple login script 
    above with minor changes.



                          SYSTEMS CONFIGURATION COMMANDS:

    After each system entry in the SYSTEMS file, there may be any number of 
    configuration commands.  These commands control the functioning of 
    UUCICO when talking to the system which they follow.  The commands and 
    their usage are:


5.2.3    CONFIGURE ULIMIT <N>

    Set the ULIMIT for this site to N, where N is a positive integer.  The 
    ULIMIT controls the maximum bytes accepted from the remote system. 
    Setting this value to 0 will cause UUCICO to send, as the ULIMIT, the 
    amount of space left on the disk containing the spool directory.  If 
    "DISABLE" is used, ULIMIT will be ignored. (MAXLIMIT, in the UUPLUS.CFG 
    file, is the maximum accepted incoming file size.)  The default is 
    shown below.

         configure  ulimit disable


5.2.4    CONFIGURE G_WINDOW <N>

    Requests a g-protocol window size of N, where N is from 1 to 7.  
    Allowed values are 1, 3, and 7.  The default is 7.

         configure  g_window 7


5.2.5    CONFIGURE G_PACKET <N>

    Specifies the requested packet size of N bytes for the g protocol.  
    Default is to use a packet request of 64 bytes.  Valid values are from 
    64 bytes to 4096 bytes in powers of 2 (e.g.  64, 128, 256, 512, 1024, 
    2048, and 4096).  Please note that quite a few UNIX systems will not 
    accept requests over 64 bytes, and quite a few others will accept the 
    request but still send 64 bytes, or break altogether. 256 is a good 
    compromise for efficiency and errors with systems that can accept 
    larger packet sizes, such as Taylor UUCP.  Change this value with care.  
    For more information on speeding up transfers, see the section 8.1, 
    "Optimizing UUPlus Utilities."

         configure  g_packet 64


5.2.6    CONFIGURE RETRIES <N>

    Instructs UUCICO to retry the connection to the remote site should it 
    fail for a non-fatal reason.  UUCICO will retry up to n times, where N 
    is 0 to 10.  The default value is 3.

         configure  retries 3


5.2.7    CONFIGURE RETRYTIMES <N<N>..>

    Sets the delay time between retries in seconds.  There may be up to 10 
    delay times. The default values are shown.

         configure  retrytimes 60,120,180

    NOTE:  If the number of retries is greater than the number of 
    retrytimes, the last value will be repeated.


5.2.8    CONFIGURE GRADECHAR <C>

    Sets the grade specification character to C, where C is either "p" or 
    "v".  Most UUCPs use "p" and is the default.  IF UUCICO connects and 
    correctly logs in but no files are transferred, try changing this 
    character to "v". If the system you are talking to is running BNU UUCP, 
    use the "v" option.

         configure  gradechar p


5.2.9    CONFIGURE PROTOCOLS <STRING>

    Overrides the default protocol list, enabling UUCICO to report 
    protocols in a different order.  With this version, only the standard 
    "g" protocol is supported, so using this option has no effect.  It is 
    allowed to support other protocols in the future.


*******************************************************************
5.3      HAYES.MDM           [LIBDIR] \ MODEM \ HAYES.MDM

                      Modem File Format for UUPlus Utilities


5.3.1    Sample MODEM Configuration file

    # modem configuration file: Hayes(tm) modem - UUPlus # Utilities 1.52
    #
    # Port for this modem. This corresponds directly to the COMport.
    # Thus, port 3 means COM3
    #
    port           1
    #
    # membase - can be set to denote a different memory base. Hex format
    # membase 3F8
    #
    # irq - can be set to denote a different IRQ
    # irq          5
    #
    # NOTE! Do not prefix these hex numbers with a zero! The system will think
    # that you're giving it an OCTAL number in that case. Use the number, or
    # optionally prefix it with "0x" as in "0x3F8"
    #
    # The trigger level for the 16550 UART chip, if your serial port is so
    # equipped. If there is no 16550 present, this setting is ignored. Valid
    # values are  1, 4, 8, 14, and DISABLE
    #
    16550trigger   8
    #
    # The size, in bytes, of UUCICO's disk buffer. This number is in hex, and
    # the "0x" is optional. A value of 0x4000 corresponds to a 32K disk
buffer.
    # Watch your available memory.
    #
    diskbuffer     0x4000
    #
    # The speed at which to initially open the serial port for communications
    # to the modem. The optional keyword "lock" may be placed after the speed
    # to bypass UUCICO's speed matching and lock the port at the specified
    # speed.
    #
    portspeed      9600
    #
    # RTS/CTS flow control on/off
    #
    hardwareflow   on
    #
    # driver for this comport. Valid entries are "internal" and "fossil"
    #
    driver         INTERNAL
    #
    # dialer for this comport. Valid entries are "hayes" and "direct"
    #
    dialer         hayes
    #
    # Timeout to detect carrier.
    #
    tcd            90
    #
    # Timeout for login phase.
    #
    tlogin         30
    #
    # Timeout for data receive.
    #
    tdata          10
    #
    # init - initialization strings. There may be any number. They will be
    # executed in the order they appear and will have a carriage return
    # appended automagically.
    #
    init           ATZS0=0S11=50
    #
    # shutdown - shutdown strings. There may be any number. They will be
    # executed in the order they appear and will have a carriage return
    # appended automagically.
    #
    shutdown       ATZ



    The following are the valid lines for the MDM files, where N is an 
    integer number, X is an integer number in hexadecimal, <TEXT> is a 
    string identifier, and <<TEXT>> is an optional string identifier.  Text 
    following a leading # is ignored at run time.  The optional parameters 
    are identified with the #.  Descriptions of the lines in the *.MDM 
    files are as follows: 


5.3.2    PORT <N>

    This is the port your modem is connected to.  1 = COM1,  2 = COM2, etc.

         port  1


5.3.3    MEMBASE <X>

    Optional, the memory base to use in hex format.  (COM1: is 3F8  COM2:2F8)

         membase  3F8


5.3.4    IRQ <N>

    Optional, the IRQ to use in hex format.  (COM1: is IRQ 4,  COM2: is IRQ 3)

         irq  4

5.3.5    16550TRIGGER <N>

    The trigger level to use should a 16550 UART be detected.  Valid values 
    are 1, 4, 8, and 14 characters.  This value specifies the number of 
    characters that the UART will store before signaling the processor to 
    process the characters.  The UART (Universal Asynchronous 
    Receiver/Transmitter) is a chip on the I/O card that converts data sent 
    from the CPU to the serial port, and vice versa.  We recommend a 
    setting of 8.  If you have an older machine with a 8250 UART, this 
    setting will be ignored.  An invalid entry or the word "disable" will 
    disable the FIFO (First In, First Out  buffer), so "16550trigger 
    disable" is recommended to turn off the FIFO buffer.  See the section 
    on UARTs later in this manual for more information.

         16550trigger  8


5.3.6    DISKBUFFER <X>

    The size, in bytes, of the disk buffer.  The larger, the  better.  
    Practical maximum seems to be around 32K.  This number is supplied in 
    hex format (e.g. 0x8000 for 32K).  The default is 0x4000, or 16K. 

         diskbuffer  0x4000


5.3.7    PORTSPEED <N> <<LOCK>>

    The initial speed to talk to the port (not the baud rate of your 
    modem).  With high speed modems and newer computers you can set this at 
    the higher rates, such as 57600.  With slower modems you will need to 
    slow the port down to prevent a UART overrun or other communications 
    errors.  For instance, if you have an older computer with a 2400 baud 
    modem, sending data at 57600 baud will overload the port and cause 
    UUCICO (the data transfer program) to generate an error. 

    Allowed port speeds are:  300, 1200, 2400, 4800, 9600 (default), 19200, 
    38400, 57600, & 115200.   Use the same or next higher speed than the 
    modem. For example, use 19200 for a 14400 modem.

    If the string "lock" follows the port speed, no rate adaption will be 
    performed.  Without "lock," if no response is detected from the port, 
    the PORTSPEED will be cycled down.  For direct connections and buffered 
    high-speed modems, the LOCK setting is highly recommended.

         portspeed  9600
         portspeed  19200 LOCK


5.3.8    HARDWAREFLOW <<ACTION>>

    Supports hardware flow control.  It is either set ON or OFF.  The 
    default is ON.

         hardwareflow  ON


5.3.9    DRIVER <DRIVER_TYPE>

    This option selects either an INTERNAL or FOSSIL driver.  INTERNAL uses 
    the internal communication driver.  FOSSIL uses interrupt 14 services 
    through BIOS, accessing any FOSSIL-compliant drivers you may have 
    loaded.  INTERNAL is the default.  

         driver  INTERNAL


5.3.10   DIALER <DIALER_TYPE>

    Supports either HAYES or DIRECT.  Hayes mode will cycle upon issuance of 
    the dialing command (found in the systems file) and wait for a CONNECT 
    situation or TIMEOUT (see progress below).  DIRECT will bypass this 
    functionality.

         dialer  HAYES



5.3.11   TCD <N>

    Time (in seconds) to wait for carrier detect.  Meaningless in a DIRECT 
    connection.

         tcd  90


5.3.12   TLOGIN <N>

    Time (in seconds) to wait for LOGIN once connection is made. 

         tlogin  30


5.3.13   TDATA <N>

    Time (in seconds) to wait for data during the actual protocol.

         tdata  10


5.3.14   INIT <INIT_STRING>

    The string or strings to send down the serial line at start of the 
    program.  For a modem, this is usually an AT string to initialize the 
    modem.  The default values will work with many modems, but you may have 
    to experiment with this to get it working properly on your system.  The 
    "AT" is required for Hayes and compatible modems, and is followed by 
    whatever is required to wake up your modem.  If you experience problems 
    when running UUCICO, you may need to consult your modem's manual for 
    the proper initialization string for your modem and system.  You can 
    also send more than one INIT string.  They will be sent in the order 
    listed in the *.MDM file, and have a carriage return appended at the 
    end of each string.

         init  ATZS0=0S11=50
         init  AT&C1

    For information on error messages, see section 9.1.



5.3.15   SHUTDOWN <SHUTDOWN_STRING>

    The string to send down the serial line at shutdown of the program.  In 
    a modem situation, this is usually an AT string to return the modem to 
    it's original state.  Usually an "ATZ" is sufficient.  Some not so well 
    behaved internal modems may have trouble hanging up the phone so you 
    might try "AT&H0" followed by "ATZ".  As with INIT, there may be any 
    number of SHUTDOWN strings.  They will be sent in the order they are 
    listed and appended with a carriage return.  Consult the manual that 
    came with your modem if you have trouble.

         shutdown  ATZ

    For information on error messages, see section 9.1.


5.3.16   MAXERROR <N>

    Optional, specifies the maximum number of errors UUCICO will allow 
    before halting.  The default is 40.

         maxerror  40

*******************************************************************
5.4      MAILRC              [BASEDIR] \ [LIBDIR] \ MAILRC

    These files control the operation of the mailer.  There can be several 
    MAILRC files, one in [LIBDIR], and one in each user's [HOME] directory.  

    Options in the user's MAILRC will override those set in the version in 
    [LIBDIR].  A MAILRC file in [BASEDIR]\HOME\[USER]\ is not necessary for 
    the system to operate.

    The format for a set command is:  SET OPTION DIRECTIVE, where SET is 
    the literal word "set", "OPTION" is the option, and "directive" is 
    either "on" or "off" in the case of a Boolean option, or an argument as 
    shown below.  This file is set up by the installer and descriptions of 
    each command are listed under "Mail Options." 


    The default MAILRC file is shown below.

         set autosig    on
         set askcc      on
         set dot        on
         set ignoreeof  off
         set nosave     off
         set record     off
         set metoo      off
         set escape     ~
         set crt        24
         set prompt     &


5.4.1    AUTOSIG

    This turns the AUTOSIG switch "on" or "off".  AUTOSIG will 
    automatically include the file \[HOME]\[USER]\SIG at the end of a mail 
    message if set to "on".  You will need to create this file with a text 
    editor after the installation process and place it in the 
    \BASE\HOME\USER\ directory for it to appear at the end of your mail.

         autosig  on


5.4.2    ASKCC

    Will prompt the user carbon copy, Cc:, addresses if set ON.


5.4.3    DOT

    Will allow a single dot (".") at the beginning of a new line to end 
    mail messages if set ON.


5.4.4    IGNOREEOF

    Will not allow a <CTRL> D to end MAIL messages if set ON.  NOTE:  DOT 
    and IGNOREEOF only effect the line editor.  If DOT is set OFF, and 
    IGNOREEOF is set OFF, DOT will be reset ON.  This is will allow 
    messages always to be closed.


5.4.5    NOSAVE

    Prevents errors from writing to the user's DEAD.LTR file in their HOME 
    directory.


5.4.6    RECORD

    If set to a path and filename, RECORD saves copies of all mail sent in 
    the file specified.  OFF suppresses saving a record.


5.4.7    METOO

    Adds the user's address to the 'To:' line of all outgoing mail if set 
    ON.  A copy is then sent to the USER as well as the RECIPIENT.


5.4.8    ESCAPE CHAR

    Defines the single character used as the escape character while 
    composing mail.  Defaults to a tilde ("~").


5.4.9    SCREEN LEN

    Defines the number of lines before pausing on long messages. The 
    default is 24.  The screen length is identified as the CRT variable in 
    the MAILRC file.


5.4.10   MAIL PROMPT

    Defines the MAIL prompt.  Default is "&".



*******************************************************************
5.5      ALIASES             [BASEDIR] \ [LIBDIR] \ ALIASES

    The aliases file controls mail aliasing on a system or user level. 
    There can be several ALIASES files, one in [LIBDIR], and one in each 
    user's [HOME] directory.  The HOME directory ALIASES file is checked 
    first, and then the system ALIASES file.  More specifically, personal 
    aliasing is done by the mailer (MAIL.EXE), while RMAIL does system 
    aliasing.  If you are using a 3rd party mailer, the ALIASES file in the 
    user's HOME directory may not be checked (sometimes in favor of an 
    aliasing mechanism provided by the 3rd party mailer).  An ALIASES file 
    in [BASEDIR]\HOME\[USER]\ is not necessary for the system to operate.

    MAIL can alias single, multiple, local, and off site mail 
    addresses.  The form is:

         alias  aliasname  address [address]

    Examples:

         alias  mayor  mayor@ourcity.gov
         alias  maillist  chief  comisr@firedept.org  mayor@ourcity.gov

    Aliasing to a local address is done using just the "username".  
    Aliasing to a off site address must include the complete address.


    The System ALIASES are processed by RMAIL.  In the case of incoming 
    mail from off site, it will be the only aliasing file processed.  In 
    the case of mail generated locally, it will be processed after the 
    user's ALIASES file is processed.  Any aliases in the system's ALIASES 
    file which match resolutions in the user's ALIASES file will be further 
    expanded.  For example in the following situation:

         user's aliases:    alias  mascot   dalmatn
         system's aliases:  alias  dalmatn  spot

    Any mail sent to 'mascot' will alias to 'dalmatn', and be sent to 
    RMAIL, which will then alias it to 'spot'.  In this case, 'mascot' gets 
    no mail, nor does 'dalmatn'.


5.5.1    NETWORK ALIASING

    Network aliasing of machines is also supported.  This allows you to 
    alias local machines so that mail to a server can be delivered locally.  
    The command is "iam".  This option is only supported in the 
    [LIB]\ALIASES file, not the version in the user's HOME directory.

         iam  firestation.slo.ca.us
         iam  firehouse.org
         iam  firesta
         iam  firedept.gov
         iam  mascot
         iam  dalmatian

    Any mail received with these addresses will be treated and delivered as 
    local mail.

*******************************************************************
5.6      SIG                 [BASEDIR] \ HOME \ [USER] \ SIG

    This optional file contains a signature for each user which will be 
    appended to any outgoing mail or news posts.  Current USENET netiquette 
    says that your SIG file should be no more than 4 lines long.

    The SIG file is appended to outgoing news and mail by default.  To turn 
    this function off, include the line:

         set autosig off

    in the users MAILRC file in \uuplus\home\user\mailrc.  If no SIG file 
    exists, no signature will be appended.


*******************************************************************
5.7      BATCHER.CFG         [BASEDIR] \ LIB \ NEWS \ BATCHER.CFG

                   BATCHER.CFG File Format for UUPlus Utilities

    This file controls how outgoing UUCP jobs which contain USENET news 
    batches are created by the BATCHER program.

         site      size    queue  builder  muncher     sender
         --------  -----   -----  -------  ----------  ------
         nextsite  40000   20     batcher  compcun 12  normal


5.7.1    SITE

    Use the same name as the SMARTHOST in the UUPLUS.CFG file (the SYSTEM 
    in the chat script of the SYSTEMS file.


5.7.2    SIZE

    Size at which last article will be processed for this batch.  Note that 
    this is size BEFORE COMPRESSION (if any).


5.7.3    QUEUE

    The number of batches that will be in the deliver queue at any one 
    time.  If you reach the maximum, batcher will exit without processing 
    any more.  UUQ must be on the execution path or in the BASE directory 
    for queue limits to function (BATCHER calls UUQ to find out how many 
    news jobs are pending).


5.7.4    MUNCHER

    "nocomp" indicates no compression.  "compcun" indicates to use internal 
    compress default of 12 bit, any numeric value between 12 and 16 may be 
    specified.

    Caution: Some systems may not have enough memory for 16 bit compression.


5.7.5    SENDER

    The site sending the News.  BUILDER and SENDER are ignored, but must 
    contain data.  These are preserved for UNIX compatibility, and/or 
    future expansion.

*******************************************************************
5.8      SYS                 [LIBDIR] \ NEWS \ SYS

    The SYS file controls which newsgroups are propagated to remote sites. 
    When NEWS comes in from a remote site, the SYS file will decide which 
    systems to send the news on to.

    The format of a SYS file entry is:

         site:newsgroups:flags:command


5.8.1    SITE

    The name of the SMARTHOST listed in the UUPLUS.CFG file (the SYSTEM in 
    the chat script in the SYSTEMS file.


5.8.2    NEWSGROUPS

    Which newsgroups to feed TO them.  Receipt of newsgroups is dependent 
    solely on our active file.  '!' negation is allowed here.


5.8.3    FLAGS

    Flags to control batching.  Currently, only the 'F' flag is used.  If 
    you do not have 'F' here, no batching will occur.


5.8.4    COMMAND

    Command for the flag.  Currently, just the name of the file in which 
    news articles bound for the batcher reside goes here. The filename will 
    be under the root [NEWS]\OUTGOING directory.


    Currently, the system is set up for all incoming news to be placed in 
    the proper directories by RNEWS.  All news posted on this site is 
    submitted to RNEWS and the proper filename is appended to a BATCHER 
    spool file.  At the appropriate time, BATCHER is run, which uses this 
    and the BATCHER.CFG file that are found in the directory 
    ([LIBDIR]/NEWS) to copy and batch news articles to be sent to the sites 
    named here via UUPlus Utilities.  It is the responsibility of the 
    system administrator to be sure that the sites in this file match those 
    in the BATCHER.CFG file, and vice versa.



*******************************************************************
5.9      ACTIVE              [LIBDIR] \ NEWS \ ACTIVE

                      ACTIVE File Format for UUPlus Utilities

    This file contains information about all the newsgroups that your 
    system knows about and would like to receive.  Each newsgroup is on its 
    own line with the following format:

         group           lseq        hseq        post
         --------------  ----------  ----------  ----
         comp.mail.uucp  0000000022  0000000142  y


5.9.1    GROUP

    Name of the newsgroup (e.g.  comp.mail.uucp)


5.9.2    LSEQ

    Number containing the lowest message available in the newsgroup. 


5.9.3    HSEQ

    Number containing the highest message available in the newsgroup.


5.9.4    POST

    Character describing the post permissions for that newsgroup. "y" 
    allows posting, "n" does not, "x" denotes a place holder newsgroup.  It 
    is equivalent to "n" in the case of posting.  "m" denotes a moderated 
    newsgroup.

    These fields are maintained automatically by the RNEWS module within 
    UUXQT, READNEWS, and POSTNEWS.  ACTMAKE and FIXACTIV also modify the 
    ACTIVE file.




*******************************************************************
5.10     NEWSRC              [BASEDIR] \ HOME \ [USER] \ NEWSRC

    This file controls how newsgroups are read.  Simply put, it contains 
    the newsgroup name, a control character, and the highest message read.  
    The control character is a colon (":") for a newsgroup that you are 
    subscribed to, and a bang ("!") for a group you are not subscribed to.  
    This file will be created automatically in their home directory the 
    first time each user runs READNEWS.

    Examples:      alt.prose!0
                   comp.mail.uucp:10
                   misc.emerg-services:25
                   news.announce.important:45



*******************************************************************
5.11     EXPLIST             [LIBDIR] \ NEWS \ EXPLIST

    EXPLIST controls the default functionality of the EXPIRE program.  
    Lines are of the format:

         newsgroup[,newsgroup] type days archdir


5.11.1   NEWSGROUP

    Comma separated newsgroups.  The "all" meta-character is valid.


5.11.2   TYPE

    "u" unmoderated only, "m"  moderated only, "x" either.


5.11.3   DAYS

    Number of days to keep the articles.


5.11.4   ARCHDIR

    Directory to archive expired articles to, or "-" for noarchive.


    Examples: 

         archive the amateur radio stuff
              rec.amateur.radio  m  7  e:\archive\hamradio

         local groups, keep for some time (a month or so)
              slo                x  28  -

         override the defaults for some of our favorites
              alt.bbs            x  14  -
              comp.dcom.telecom  m  14  -

         hold most groups for a week
              comp,sci,rec,talk  x  7   -

         all the rest, keep for 4 days
              all                x  4   -



*******************************************************************
5.12     HEADERS             [LIBDIR] \ NEWS \ HEADERS

    The HEADERS file controls the displaying of Headers within news.  The 
    provided file is set up for a standard news configuration.  You may 
    edit it to insert any headers you wish, however DO NOT delete any of 
    the pre-existing headers or else UUXQT will have difficulty processing 
    incoming news.

    If header comparison is to be strictly case sensitive, add a line with 
    the keyword "casesense"

    To choose the colors for header and text display, use the COLOR 
    keyword, followed by the IBM text colors for headers, highlighted 
    headers, and text.

         color 3 14 11


5.12.1   EXTENDED HEADERS

    These will be added to all outgoing posts after editing the files.  You 
    may put whatever you want here, but note that certain headers aside, 
    from the "X-" approved extended syntax, may draw flames.

         extend X-pizza-toppings: extra cheese and mushrooms


5.12.2   HEADER DIRECTIVES

    HILIGHT   To highlight a header

    IGNORE    To ignore a header.  Will only be displayed if the article is
              restarted in "verbose" mode


5.12.3   Example HEADER File:

         # header:          Directive:

         Path:              IGNORE
         From:              HILIGHT
         Newsgroups:
         Subject:           HILIGHT
         Summary:
         Keywords:
         Message-ID:
         Date:
         Expires:           IGNORE
         Control:           IGNORE
         Sender:
         Reply-To:
         Followup-To:
         Distribution:
         Organization:
         Lines:
         Approved:
         News-Software:
         References:        IGNORE
         Originator:
         Xref:              IGNORE
         Article-I.D.:
         Nntp-Posting-Host: IGNORE



*******************************************************************
5.13     MODRECDG            [LIBDIR] \ NEWS \ MODRECDG

    This file is displayed when a user attempts to post to a moderated 
    newsgroup.  It informs the user that the newsgroup is moderated, and 
    suggests that they send mail to the moderator instead.



*******************************************************************
5.14     RECORDIN            [LIBDIR] \ NEWS \ RECORDIN

    This file is displayed before a post editing session is started.  It 
    usually informs the user that the post they are about to send could 
    cost the net lots of bandwidth and money to send, and do they REALLY 
    want to send it?  Or, it may remind a user not to post any proprietary 
    information.

--
*----------------------------------------------------------------------------*
|John Bonnett  -  UUPlus Development  -  P.O.Box 6991  -  Los Osos, CA. 93402|
|Internet: jhb@uuplus.com   -   Voice: (805) 534-1425  -  Fax: (805) 534-9502|
*----------------------------------------------------------------------------*


                             UTILITY DESCRIPTIONS

                                  Section 6.0
                                   1/10/1995

    The following section describes the UUPlus Utilities 1.52
    Programs & Utilities.


Communication:

    UUCICO.EXE     Send/Receive Mail, News and Files ............. 6.1
    UUXQT.EXE      Process and stores received Mail, News,
                   and Files ..................................... 6.2


File Transfer:

    UUCP.EXE       Send Files .................................... 6.3


Mail:

    MAIL.EXE       Read and Write Mail ........................... 6.4
    RMAIL.EXE      Called by other programs to send mail ......... 6.5
                   RMAIL and Disk Caching ........................ 6.5.2


News:

    POSTNEWS.EXE   Send News ..................................... 6.6
    READNEWS.EXE   Read News ..................................... 6.7


News Utilities:

    ACTMAKE.EXE    Create Active File From Stored News ........... 6.8
    BATCHER.EXE    Prepare News for Transfer ..................... 6.9
    EXPIRE.EXE     Expire Old News ............................... 6.10
    FIXACTIVE.EXE  Correct Errors in Active File ................. 6.11
    UUCLEAN.EXE    Clean out Old Files ........................... 6.12

General Status:

    UULOG.EXE      Show Traffic Status ........................... 6.13
    UUQ.EXE        Show Files Ready for Transmission ............. 6.14
    UUSNAP.EXE     Abbreviated UUQ ............................... 6.15
    FROM.EXE       List Incoming Mail ............................ 6.16


Additional Programs:

    COMP.EXE       News Compressor ............................... 6.17
    DECOMP.EXE     News Decompressor ............................. 6.17

******************************************************************
6.1      UUCICO.EXE


    UUCICO.EXE implements a standard 'g' protocol transfer mechanism for 
    UUCP mail and Usenet news.  It calls the remote site (system), 
    identifies itself, then sends the files in the queue (\spool\uucp\ 
    smarthost\A-Z).  When all outgoing files are transferred, UUCICO checks 
    to see if the host has any mail and news for your site.  Incoming 
    files are placed in  \spool\uucp\smarthost.


    Usage:

         uucico [-s system] [-x debug] [-h] [-g grade] [-ln] [-v] [-f
filename]

         Note: A space is shown between the -option and the command for 
         clarity.  When UUCICO is invoked, only a space BEFORE the "-" is 
         allowed.  For example, if our smarthost is "nextsite", and we 
         wanted a verbose log of the data transfer,  and the DEBUG file is 
         "debug.001", then the command line would look like:

              uucico -snextsite -x5 -fdebug.001


    -s   SYSTEM.  This argument is MANDATORY! (All others are optional).  
         This is your "smarthost" (service provider),  the site specified 
         with "-s" must be in the SYSTEMS file or an error will be 
         produced.

    -x   This option allows for specifying a DEBUG level from 1 to 9.  The 
         debug level provides different amounts of information necessary 
         for debugging a connection.  1 provides the least information, 9 
         the most. Once a connection is stable, debug level 3 or 4 is 
         usually sufficient.  If this option is omitted, UUCICO will use 
         the debug level of that specified in the UUPLUS.CFG debuglevel 
         parameter.

    -g   Runs UUCICO at the specified grade and above.  The highest grade 
         for UUPlus Utilities is "A" and the lowest is "Z".  This setting 
         can be used to prevent news from transferring during peek usage 
         times or when phone costs are higher.  The default grade for mail 
         is "D" and news is "N".  Setting the grade to "D" would allow mail 
         to be transferred, but not news.  If no grade is specified, "Z" is 
         assumed and all mail and news will be transferred.

    -v   Will print the current version number of UUPlus Utilities.

    -h   The "ignoreHost" option tells UUCICO to ignore the host name sent 
         by the remote machine.  This is used to maintain compatibility 
         with some older versions of UUCP.  If the message "Shere error" is 
         encountered during the Negotiation phase of file transfer, try 
         again with this option.

    -ln  The maximum length (number of characters) of the SITENAME to be 
         specified when calling a remote system.  This switch is intended 
         to provide compatibility with systems that do not follow the UUCP 
         standard of a maximum of 8 characters in a SITENAME.  The value 
         specified here will override any value set in the UUPLUS.CFG file.

    -f   This option allows debug information to be diverted to the named
         file.

    It is recommended that UUCICO be run from a batch file.  See sections 
    6.2 and 7.4 for examples.


    UUCICO will return an integer exit code readable by a calling program, 
    or via the ERROR LEVEL variable in a batch file.

    The codes are:

         0  -  Poll completed OK
         1  -  User termination request
         2  -  Configuration error
         3  -  Bad parameter in command line
         4  -  Bad site specified in -s option (or not site specified)
         5  -  Error initializing modem, error in .MDM file
         6  -  Did not receive connection to remote site
         7  -  Error starting up protocol
         8  -  Error during protocol transfer
         9  -  Exit after startup with -? option
         10 -  System problem, catch-all

    All error codes 1 through 5 indicate that something is wrong with the 
    setup or configuration on either the UUPlus Utilities or remote host 
    side.  Error level 7 indicates that there was some problem during 
    transmission, and a retry will usually continue where the error left 
    off.  Error 8 indicates a problem during the actual transfer, and a 
    retry may solve the problem.


******************************************************************
6.2      UUXQT.EXE


    UUXQT process and places incoming data files from UUCP transfer in the 
    proper directory.  UUXQT reads the files in  \spool\uucp\smarthost, 
    invoking DECOMP to uncompress news files, then placing mail files in 
    \spool\mail  with each recipient's "username" as the file name, and 
    news files in their respective news directory.  News files are given a 
    numeric file name corresponding to the order in which they were 
    processed and the numbers indicated by the active file.

    Usage:

         uuxqt [-s system] [-x debug] [-f filename]

    Note: A space is shown between the -option and the command for clarity.  
    When UUXQT is invoked, only a space BEFORE the "-" is allowed.  For 
    example, if our smarthost is "nextsite", and we wanted a verbose log of 
    the data transfer,  and the DEBUG file is "debug.001", then the command 
    line would look like:

         uuxqt -snextsite -x9 -fdebug.001


    UUXQT should be invoked after a call with UUCICO.  It is recommended 
    that you do this via a batch file, for example:

         uucico -snextsite -x5 -fcico.dbg
         uuxqt  -snextsite -x5 -fxqt.dbg



    Optional Parameters:

    -s   The system must be a system name specified in your SYSTEMS file.
         If no system name is given, UUXQT will process all systems.

    -x   This option allows for specifying a DEBUG level from 1 to 9.  The 
         debug level provides different amounts of information necessary 
         for debugging a connection.  1 provides the least information, 9 
         the most.  Once a connection is stable, debug level 3 or 4 is 
         usually sufficient.  If this option is omitted, UUXQT will use 
         the debug level of that specified in the UUPLUS.CFG debuglevel 
         parameter.

    -f   This option allows debug information to be diverted to a file.

    See section 7.4 for more examples.


******************************************************************
6.3      UUCP.EXE


    This program is the Unix to Unix COpy program for file transfer.

    Usage:

         uucp [-c] [-ssystem] [-ffilename]

    Where [-c] creates a copy, [-s] is the system, and [-f] is the file to 
    be transferred.  If the -c option is omitted, the execute file (X. 
    file) will reference the actual file to be transferred, instead of 
    creating a copy in the spool directory.

    UUCP.EXE is used for file transfer to a system that you talk to 
    directly or that you are networked with via UUCP.  It is not used for 
    normal mail and Usenet news transfers.


*******************************************************************
6.4      MAIL.EXE

    MAIL is an RFC-822 compliant mailer subset.  This program is as close 
    to UNIX(tm) MAIL as possible.  Usage is as follows:

    To Read mail:

              mail [-f user]

    To Send mail:

              mail [-r filename] [-s subject] name [name name]

         Note:  In the above examples, a space is used after the "-" option 
         letter for clarity.  In the following examples the space is 
         omitted.


6.4.1    Reading Mail.

    For reading mail, simply type MAIL.  The mail file for the user set 
    with the USERNAME variable or the user listed in the username directive 
    in the UUPLUS.CFG file will be used.

              mail

    To specify a specific mailbox (mail file), use the "-f" option.  The
    "-f" option starts MAIL using the filename that is specified instead of 
    the default mail spool.  There is no account security provided for 
    access to mailboxes.

              mail -fchief



6.4.2    Sending Mail.

    For sending mail, type MAIL, followed by any command line options, and 
    a single or list of valid addresses or aliases.

              mail  chief
              mail  chief mayor@cityhall.ourcity.gov

    MAIL will accept a single word subject on the command line with the
    -s option.

              mail -sGreetings mayor@cityhall.ourcity.gov 

    For file transfer, MAIL accepts the "-r" option.   In this example, the 
    ASCII text file "message.txt" would be sent to "mayor" at "city.gov".

              mail -rmessage.txt mayor@cityhall.ourcity.gov

    The "-a" option will dump a list of MAILRC and ALIASES information.

    Mail aliasing is handled through 2 files:

    [HOME]\[USER]\ALIASES is the individual user aliases.  It is checked 
    before the system aliases file. 

    [LIBDIR]\ALIASES contains system wide aliases.  It is checked after the 
    mail has been composed and set to RMAIL.EXE.  No address rewriting 
    takes place on aliases placed herein.  All mail coming in from off-site 
    is passed through this file for aliasing by RMAIL.EXE



6.4.3    Receive Mode Commands.

    To get help in receive mode, type "?".  The following is the list of 
    commands supported inside MAIL:

   <n>   -  To display a message, enter the number of the message.
    d    -  Delete message.  "d<n>" deletes #n message
    dp   -  Delete message and read the next
    h    -  Display headers
    i    -  Information about current message
    m    -  Send mail
    n    -  Next message (also return)
    p    -  Print or display message
    q    -  Quit mail, save the changes
    r    -  Reply to sender
    R    -  Reply to sender, recipient(s) and Cc:(s)
    s    -  Save mail, with headers (specify filename)
    u    -  Undelete message
    v    -  Show mail version
    w    -  Save mail, without headers (specify filename)
    x    -  Exit mail, do not save changes

    When reading mail, at the  "---More---"  prompt, the <Spacebar> will 
    scroll the text one page at a time, pressing <Enter> will advance the 
    text one line at a time, <PageDown> will advance to the next mail 
    message.



6.4.4    Composition Mode Commands.

    If the EDITOR directive in the UUPLUS.CFG file is set to "line",  the 
    following commands are available.  If EDITOR is set to "visual" then 
    only the commands in the named editor can be accessed.

    To get help in MAIL's composition mode (sending mail), type "~?" on a 
    new line.  See "Mail Options" for more information on MAIL's defaults.  
    The following is the list of Tilde escapes supported inside mail:

    ~b users       -  Add users to blind Cc:, (Bcc:) list
    ~c users       -  Add users to Cc: list
    ~d             -  Read in DEAD.LTR
    ~f number      -  Read in message number
    ~h             -  Prompt for to:, subject:, and Cc: list
    ~p             -  Print message buffer
    ~q             -  Quit with mailbox update
    ~r filename    -  Read in filename
    ~s subject     -  Set subject
    ~t users       -  Add users to list
    ~v             -  Shell to VISUAL editor
    ~w filename    -  Write letter to filename
    ~x             -  Exit without updating the mailbox
    ~?             -  Help with ~ escapes
    <CTRL> D       -  Done, update the mailbox
    .              -  A single dot is the same as <CTRL> D, (if "dot"is set
                      "on")


*******************************************************************
6.5      RMAIL.EXE


    RMAIL provides 3rd party support to the UUPlus Utilities mail 
    mechanism, and is intended to be called by another program.  While 
    UUPlus Utilities applications use an internally linked version of 
    RMAIL, the RMAIL application provides a command-line link to the RMAIL 
    facility.  The calling convention is:

         rmail recipient file sender

    recipient  The recipient of the mail.  A valid RFC-822 address is 
               required here (or the name of a local mailbox).

    file       Is the file to read from.  This should contain the text of
               the message in addition to all necessary header fields.  See 
               "Header Fields" below.

    sender     Is the person sending the mail, if local.  If there is no 
               sender, it's assumed that the mail is from off site and no 
               "From" header will be constructed.  Rmail assumes the 
               "sysname" in the UUPLUS.CFG, so "sender" should be simply 
               the "username".

    A single space between arguments is required.  No other spaces are 
    allowed.


    Example:

         rmail mayor@cityhall.ourcity.gov c:\outmail\ltr2myr.txt chief

    This would send the file  "c:\outmail\ltr2myr.txt"  to
    "mayor@cityhall.ourcity.gov"  from  "chief".

    The file to be sent should have the following format:

              From:
              Date:
              Subject:
              To: 
                  <space>
                  <message>
                  <signature>

    So the header of the file to be sent might look like this:

              From: chief@firesta.com (Chief Firefighter)
              Date: Mon, Jan 2, 1995 09:54:44 PST
              Subject: Bar-B-Q at my house!
              To: mayor@cityhall.ourcity.gov

          
    Note:  The "From: ", Date: ", "Subject: " and "To: " lines are 
    required.  There should be a blank line between the "To:" line and the 
    message.


    Rmail will add these lines to the header:

         From chief Mon, Jan 2, 1995 09:54:44 PST
         Received: by firesta.com (UUPM-1.52)
              id D4614dA Mon, Jan 2, 1995 09:54:44 PST
         Message-Id: <9412261554.D4614dA@firesta.com>
         X-Mailer: UUPlus Mail 1.52


    So the final output would be:

         From chief Mon, Jan 2, 1995 09:54:44 PST
         Received: by firesta.com (UUPM-1.52)
              id D4614dA Mon, Jan 2, 1995 09:54:44 PST
         From: chief@firesta.com (Chief Firefighter)
         Message-Id: <9412261554.D4614dA@firesta.com>
         X-Mailer: UUPlus Mail 1.52
         Date: Mon, Jan 2, 1995 09:54:44 PST
         Subject: Bar-B-Q at my house!
         To: mayor@cityhall.ourcity.gov

         Dear Sir,

         We are having our annual Bar-B-Q at my house tomorrow night.
         See you at 6:00!

         --
         Chief Firefighter  -  You light 'em,  We fight 'em.  -
                                   (So don't Flame me!)
         -----------------------------------------------------------

    

6.5.1    RMAIL will return the following exit codes:

    OK:
         0  -  EXIT_OK

    Errors:

         100  -  ARGC
         101  -  CONFIG
         102  -  RESOLVE
         103  -  INVALID_SITE
         104  -  NO_SMARTHOST
         105  -  NVALID_SMARTHOST
         106  -  NO_SEQ
         107  -  NO_SEQ_FILE
         108  -  OPEN_TEMP
         109  -  APPEND_MBOX
         110  -  XFILE_CREATE
         111  -  XFILE_CLOSE
         112  -  CFILE_CREATE
         113  -  CFILE_CLOSE
         114  -  ID_SOURCE
         115  -  ID_TARGET
         116  -  NULL_SOURCE


6.5.2    RMAIL and a Disk Cache

    Note:  If RMAIL is used with a software disk cache, such as Microsoft 
    SmartDrv or Norton NCache, the possibility of an abnormal program 
    termination exists, resulting in lost mail.  This occurs when RMAIL is 
    called in rapid secession from another program, and the data in the 
    cache buffer gets overwritten.  Due to the complexity of detecting what 
    disk cache is operating, the solution to the problem, if you encounter 
    it, is either disabling the disk cache during calls to RMAIL, or to 
    perform a disk read between calls to RMAIL.


    Programming Example:

    Create a batch file with the following line repeated 25 times:

         rmail user@noaddress.com test.dat sender

    where "user@noaddress.com" is a bogas address, "test.dat" is a short 
    outgoing mail file, and "sender" is your username.  Run the batch file.  
    If there are errors, "Abnormal program termination" is displayed on the 
    screen.  This is a DOS message, not a RMAIL message.  If no "Abnormal 
    program termination" messages are displayed on the screen, you don't 
    have a problem, though you may want to change the file size and rerun 
    the test.

    If you encounter errors, add the line:

         dir *.bat /b > d.tmp

    after each RMAIL call and run the test.  The extra disk read and write 
    flushes the buffer and no errors are encountered.  Be sure to delete 
    all the test files created in the  \spool\uucp\smarthost\D  directory 
    after testing.


    If you have no control over the program that calls RMAIL, you can run 
    the following test:  Prepare 25 outgoing messages, run the program 
    that invokes RMAIL, and check the  \spool\uucp\smarthost\D  directory.  
    There should be 75 files.  Any less and there is a problem.  Turn off 
    disk caching and rerun the test.


*******************************************************************
6.6      POSTNEWS.EXE


    This program allows you to post news to the USENET network.  Articles 
    posted with this program must be "batched" using BATCHER.EXE before 
    being transferred, but are added immediately to the local newsgroups.  
    POSTNEWS will prompt you along the way for information regarding your 
    post, allow you to edit the text, and then place the post in the proper 
    newsgroup directory as well as making any arrangements to forward the 
    news to sites downstream as controlled by the SYS file found in 
    [LIBDIR]/NEWS.

    The following is a sample of screen output if you run POSTNEWS from the 
    DOS prompt.  User responses are shown.


         Loading active file...

         Is this message in response to some other message? n

         Newsgroup to post to: ?
         List of active newsgroups:
         --------------------------
         comp.bbs.misc
         alt.bbs.myfavoritebbs
         comp.bbs.yourfavioratebbs

         Newsgroup to post to: comp.bbs.misc
         Title: Test Message

         Distribution []: usa

                       (Valid responses are:
                                local   Local to this site
                                city    Local to your city or area
                                usa     Everywhere in the USA
                                na      Everywhere in North America
                                world   Everywhere on the planet)

    If you are using a VISUAL editor, POSTNEWS will now shell to that 
    editor and place the following on the screen:

         Newsgroups: comp.bbs.majorbbs
         Subject: testing
         Expires:
         References:
         Sender:
         Reply-To: jhb@uuplus.com (John H. Bonnett)
         Followup-To:
         Distribution: usa
         Organization: My Organization
         Keywords:

    You can place your message following the above.  Lines in this header 
    that you don't want to send can be deleted or edited.  There is no help 
    screen from within POSTNEWS.



*******************************************************************
6.7      READNEWS.EXE


    This program is a subset of the standard READNEWS system.  It allows 
    access to the newsgroups and articles received via UUCP transfer.  Some 
    features are not implemented due to the constraints of the PC, while 
    others will be implemented in the future.

         Usage:    readnews [-c] [newsgroup]

    The "-c" option checks all currently subscribed-to newsgroups and 
    reports back with the number of new messages in each.

    Upon startup, READNEWS performs a sanity check between the NEWSRC and 
    ACTIVE files.  If a newsgroup is in the ACTIVE file but not in the 
    NEWSRC, the user is prompted to add this group as a new group.  If the 
    converse of this is true (i.e. a newsgroup is in the NEWSRC but not in 
    the ACTIVE file), then READNEWS will remove it from the NEWSRC and 
    inform the user that a bogus group was found and removed.

    Reading all groups is usually as simple as pressing the <spacebar> when 
    a prompt is offered.  Pressing "h" displays the help screens.


*******************************************************************
6.8      ACTMAKE.EXE

    ACTMAKE uses the newsgroups in the ACTIVE file to create the proper 
    directories for news storage under the [NEWS] base directory.  All news 
    files are kept in a hierarchical directory tree under the [NEWS] base 
    directory. Each newsgroup is comprised of directories leading down the 
    tree until the final directory specifies the newsgroup.  The article 
    itself is then stored as a single file with the name being the article 
    number.

    ACTMAKE should be run after making any changes to the ACTIVE file.  


    Examples:

    Newsgroup rec.sports.baseball, with [news] as c:\uuplus\news would be 
    stored as:

         c:\uuplus\news\rec\sports\baseball

    The 46th article in this newsgroup, then, would be:

         c:\uuplus\news\rec\sports\baseball\46

    Note that article numbers are not reset as lower articles are expired. 
    It is, then, perfectly normal to have articles ranging from 4000 
    through 4200, for example, if the first 3999 articles had been expired 
    (see EXPIRE.EXE).

    When adding new newsgroups, it's often easiest to add to the active 
    file, and just run ACTMAKE.  ACTMAKE will not remove newsgroup 
    directories that are not mentioned in the active file; these need to be 
    removed manually, as the data contained within them may still be 
    wanted.

    In addition to the directories for newsgroups, ACTMAKE also verifies 
    that the outgoing directory is present to allow for news batching to 
    take place.


*******************************************************************
6.9      BATCHER.EXE


    BATCHER will take articles, specified in the [NEWS]\OUTGOING\[SYSTEM] 
    file, and batch them for transmission via UUCICO.  Based on the 
    information in the BATCHER.CFG file, BATCHER will create, compress, and 
    queue transmission files.  Queued files are normally placed in the 
    \SYSTEM\N directory.  If NEWSGRADE is set to something other than "N", 
    the outgoing news files will be placed in that directory.


    Optional parameters:

    -s   This flag allows you to specify which SYSTEM to batch news 
         articles for, without it, it will batch for all systems with batch 
         files.

    -v   This option specifies "verbose" mode. If this flag is used, then 
         BATCHER will show all the actions that it takes in preparing 
         batches.  Without the "-v" option, batcher will display the 
         copyright, but not output any information.  This "quiet" mode is 
         the default as some systems run BATCHER often and don't want all 
         the output.

    -d   This option specifies "done" mode.  If this flag is used, then 
         BATCHER creates a file in the [NEWS]\OUTGOING directory named 
         after the system being batched with an extension of .DON, and 
         places the full file names of all articles successfully batched in 
         it.  This option makes the use of direct-inject gateways much 
         simpler, as they can know which articles to delete after BATCHER 
         processes them.


*******************************************************************
6.10     EXPIRE.EXE


    Expire removes news articles that are "n" days old.  The value for "n" is 
    specified in the EXPLIST file, or overrided with the -d option.


    Optional Parameters:

    -g   Lets you specify a specific group or group set to expire.

              expire -g rec
              expire -g comp.sys.all
              expire -g comp,rec,alt.sys.all

    -d   Allows you to override the expire value that is specified in the 
         EXPLIST file.

              expire -d4

    -t   Runs in test mode, showing its actions but not performing any 
         expirations.

    -v   Runs EXPIRE in verbose mode, so that all debugging output is 
         displayed.


*******************************************************************
6.11     FIXACTIV.EXE


    FIXACTIV reads the current ACTIVE file, and scans the USENET news 
    directories for the lowest and highest articles, repairing the ACTIVE 
    file to these values.

    Warning:  If there are no articles, ACTIVE will be set to 0 for that 
    newsgroup.  To override this function, set the [-r] option to retain 
    the highest article number, and prevent de-synchronization with a users 
    NEWSRC file.


*******************************************************************
6.14     UUCLEAN.EXE


    UUCLEAN will remove old UUCP queue files from the spool.  Time is based 
    on the number of days old the files are.  Syntax:

         uuclean [-o time] [-C time] [-D time] [-X time] [-T time] [-s system]

    -o   Outgoing Files

    -C   *.C?? (Command) files

    -D   *.D?? (Data) files

    -X   *.X?? (eXecute) files

    -T   Test mode.

    -s   Restrict to system



*******************************************************************
6.13     UULOG.EXE


    This program displays UUCP log entries for systems or users from the 
    LOGFILE.

    Optional parameters:

    -s system:   Restrict log display to SYSTEM named

    -u user:     Restrict log display to USER named


*******************************************************************
6.14     UUQ.EXE


    UUQ displays detailed information about the list of all UUCP jobs 
    queued and ready for transfer.

    Optional Parameters:

    -l   This option displays the information in "long" format, providing 
         more detailed information regarding queued jobs.

    -s   This option provides output for only the specified SYSTEM.  
         Without this option, queue information for all systems will be 
         displayed.

    -d   This option, with the job number, DELETES that job from the queue.

    -v   This option will verbosely report scan progress.  It's messy, but 
         good for debugging system recognition.



*******************************************************************
6.15     UUSNAP.EXE


    This program displays a "snapshot" list of all UUCP jobs queued and 
    ready for transfer, as well as jobs in the queue waiting to be 
    processed.



*******************************************************************
6.16     FROM.EXE


    FROM displays a list of received mail for the current user.


*******************************************************************
6.17     COMP.EXE / DECOMP.EXE

    
    COMP and DECOMP, like Rmail, provide 3rd party support to the UUPlus 
    Utilities news compression and decompression mechanism, and are intended 
    to be called by another program.  They can be called from the command 
    line as follows:

         comp infile outfile level
         decomp infile outfile

    infile    The file to be processed.

    outfile   The destination file.

    level     The level of compression (for COMP only).  Level can be any
              number between 12 and 16.  12 is the normal level of
              compression.



*******************************************************************
                   Testing Your UUPlus Utilities Connection

                                   Section 7


    Testing UUPlus Utilities .............................. 7.0
    Testing MAIL.EXE ...................................... 7.1
    Testing With No Traffic ............................... 7.2
    Testing With Traffic .................................. 7.3
    Using UUPlus Utilities ................................ 7.4



7.0      Testing UUPlus Utilities.

    You've got your hardware set up, all the configuration files edited, 
    and your host account arranged with your service provider.  It's time 
    to test!  First off, do not be discouraged if it doesn't work right the 
    first time.  As stated earlier, UUCP is a tricky protocol to set up.  
    If you experience trouble, read carefully Section 6 on Utility 
    Descriptions.  Section 9 on Error Messages will also help you pin down 
    problems.  Almost all of the time problems can be solved with the 
    proper configuration of UUPlus Utilities.



7.1      Testing MAIL.

    Before we send messages off site, let's get a feeling for the way MAIL 
    works.  Start by sending mail to "spot".  At the DOS prompt, type:

         mail spot

    This will invoke MAIL.EXE with a  To:  address of "spot".  If you don't 
    have an aliases listing for "spot", MAIL assumes that "spot" is a user 
    on this system and will forward this message to "spot".  You are first 
    prompted for the Subject.  After typing the Subject, press <Enter> and 
    you will find yourself in either the LINE EDITOR or the VISUAL EDITOR, 
    depending on the setting in the UUPLUS.CFG file.  Type your message to 
    "spot", then save and exit the editor.  MAIL will prompt you to send, 
    edit, or abort.  Choose Send (enter "s"), and MAIL will forward the 
    mail to "spot".

    Now, invoke MAIL with the -f option, followed by "spot"

         mail -f spot

    MAIL will run in the read mode and you should find a message to "spot" 
    from you.  Press <Enter> to read the message.


7.2      Testing With No Traffic.

    The first thing you should do is start a UUCICO session with no traffic 
    on your end.  For those who started playing with the package before 
    reading this manual, you probably have some mail and maybe even some 
    news queued up. You can either delete it with UUQ, or skip to testing 
    with traffic.

    For example purposes, let us assume the following:

         sysname:       firestation.org
         logname:       firesta
         remote host:   cityhall.ourcity.gov

    We have an entry for "cityhall" in our SYSTEMS file, and our SMARTHOST 
    is set to "cityhall" as well.  So let's call "cityhall" and see what 
    happens.  Issue the following command:

         uucico -scityhall -x5 -fdebug.001

    If UUCICO is on the path and everything is set correctly, UUCICO should 
    pick up the phone, dial "cityhall", and talk briefly.  Ideally, they 
    will connect, exchange initialization information, and find that they 
    have no work for each other.  If you get a closing message of anything 
    other than "Poll Complete," there's a problem.  That message, in 
    addition to any information in the debug file, DEBUG.001, as well as 
    the logfile found in [SPOOL]/UUCP/LOGFILE  will help you determine the 
    problem.  You may even want to up the debug level from 5 to 8 or 9 if 
    you have problems.


7.3      Testing With Traffic.

    Now we're ready to send something.  When testing UUCP, both sending and 
    receiving need to be tested thoroughly.  Let's queue up some mail, 
    first.  Assuming that you know someone on your host machine, send them 
    a few letters:

         mail mayor@cityhall.ourcity.gov

    Let them know that you're testing your new mail feed.  If you don't 
    know anyone on the remote system, you can still test by sending mail to 
    an obviously unused account.  This serves the dual purpose of testing 
    both ways, since the remote matching will send you mail back telling 
    you you've sent mail to someone that doesn't exist.

         mail nobody@cityhall.ourcity.gov

    Unless someone has an account called "nobody", there shouldn't be a 
    problem.  Now, invoke UUCICO.  The machines should connect, negotiate, 
    and you should see information transferred.

    Hopefully, by this point, you're getting data back as well.  Be it from 
    a news feed, or mail, it has to be processed.  The program that does 
    this is UUXQT.EXE.  UUXQT will take the data that came in over UUCICO 
    and place it where it belongs.  Invoke it as:

         uuxqt -s [systemname]

    If you do not specify a system, UUXQT will process all systems.  Let's 
    just stick with one for now.  UUXQT should then bring up a display and 
    let you know what it's putting away.  It logs all it's activity to 
    [SPOOL]\UUCP\LOGFILE if you want to check it later.

    At this point your incoming mail and/or news should be put away and be 
    ready for you to read.  To read your mail, type:

         mail

    If you are the user listed in username in UUPLUS.CFG, your mail will be 
    displayed ready for you to read.  I you are not, invoke mail with the
    -f username  option as mentioned above.  See section 6.4 for more 
    information on using MAIL.

    If you have a news feed, run READNEWS to read your news.

    There is more information on each of the UUPlus programs, what they do, 
    and how they work in Section 6.



7.4      Using UUPlus Utilities.

    To be completed.
--
*----------------------------------------------------------------------------*
|John Bonnett  -  UUPlus Development  -  P.O.Box 6991  -  Los Osos, CA. 93402|
|Internet: jhb@uuplus.com   -   Voice: (805) 534-1425  -  Fax: (805) 534-9502|
*----------------------------------------------------------------------------*

                         Optimizing UUPlus Utilities 1.52

                                Hints and Tips

                                   Section 8

                                   1/10/1995

    Introduction ............................................ 8.0

    How Can UUPlus Utilities Be Sped Up? .................... 8.1.1

    Larger Packet Sizes and Increased Throughput ............ 8.1.2

    Selecting the right Packet Size ......................... 8.1.3

    UARTS and Speed Considerations .......................... 8.2

    Using a Disk Cache ...................................... 8.3

    Loss of Data Due to Disk Writes ......................... 8.4

    Alternate Drivers for UUCICO.EXE ........................ 8.5

    What About Memory Requirements? ......................... 8.6

    How Can I Get UUCICO To Retry If My Host Is Busy? ....... 8.7



8.0      Introduction.

    The UUCP suite of programs can be very tricky to set up and operate. 
    With this in mind, here are some tips and tricks for the operation of 
    UUPlus Utilities.  The material here represents some of the most 
    frequently asked questions, as well as some 'insider' hints that might 
    be found to be helpful.



8.1.1      How Can UUPlus Utilities Be Sped Up?

    Transfer rates can be increased by optimizing the packet size, if your 
    host provider allows this.  This is the #1 best way to increase the 
    speed of your transfers, aside from buying a faster modem and 
    computer...



8.1.2      Larger Packet Sizes, and Increased Throughput.

    The g-protocol that UUPlus Utilities UUCICO.EXE uses will support 
    packet sizes from 64 bytes up to 4096 (4K) bytes, in intervals of 
    powers-of-2 (e.g. 64, 128, 256, 512, 1024, 2048, and 4096).  Selecting 
    the proper packet size can increase your throughput tremendously, but 
    can be somewhat tricky, so here are a few hints and guidelines.

    First, let's answer the question, "Why increase packet size?"  With 64- 
    byte packets, the overhead in the g-protocol is considerable.  With 
    each packet, there is a header and an acknowledgment sent back.  Simple 
    math will show that the larger the packet size, fewer packets will need 
    to be sent, decreasing the overhead per file.

    There are several considerations to keep in mind when selecting packet 
    sizes.  First, can your host provider handle sizes greater than 64 
    bytes?  Many older UUCP implementations have 64-byte packet sizes hard 
    coded.  With the modernization of modem technology, the need for larger 
    packets has become more pressing, and so newer UUCP implementations 
    have begun to support them.

    Second, if your host provider is running a newer version of UUCP, why 
    won't larger packet sizes work?  Sometimes the host provider is running 
    a newer UUCP, but has not configured their modem pool to run 
    efficiently with larger packets. Keep in mind that with 4K packets, the 
    computer on their end is streaming 4K of data to their modem in 
    continuous chunks. With port speeds in excess of 57.6K BPS, that is 
    much more data than the modem can handle.  The result is an overflowed 
    buffer on the host side, and checksum errors on your side.  Often, with 
    a hardware configuration like this, 256-byte packets is the theoretical 
    limit that can be expected from your provider.  Thankfully, as UUCP 
    service providers learn more about their setups (remember, this is a 
    new field!), they are becoming able to support better buffering and 
    larger packets.

    The simple way to check if your host provider supports larger packet 
    sizes is to simply change the value of the g_packet configuration value 
    in your systems file, and run UUCICO.  The line in your systems file 
    should look like:

         configure g_packet 4096

    (note that 4096 is a selection for 4K packets.  You can put any valid 
    packet selection value here).

    If your host provider does not support the largest packet size, you can 
    expect colorful errors in the form of checksum errors, packet-header 
    xor errors, or even a complete protocol lockup.  Simply reset your 
    computer, and try again with a different packet size, or return to 64- 
    byte packets.  If you discover that only 64-byte packets work, you can 
    be fairly sure that they are running an older UUCP package.  If you can 
    get packet sizes up to 256 or 512 to run, but not higher, they probably 
    have a modem buffering problem.  A call to your host provide may help 
    solve the problem.



8.1.3    Selecting the right Packet Size.

    Selecting the optimum packet size is mainly trial-and-error.  Try each 
    size that works well with your provider, and keep a record of the CPS 
    rate on your transfers.  Try to poll when you have large files, as 
    larger files report CPS more accurately. 100K to 200K news batches are 
    ideal for testing.

    In testing, we found that different packet sizes worked with different 
    providers.  Most seem to get the best performance at either 256-byte or 
    1K-byte packets.  Your mileage may vary.



8.2      UARTS and Speed Considerations.

    The UART (Universal Asynchronous Receiver/Transmitter) is a chip on the 
    I/O card that converts data sent from the CPU to the serial port, and 
    vice versa.  One common problem experienced with UUCP transfers by 
    UUPlus Utilities is loss of characters due to UART overrun.  The 
    problem is caused when a character coming into the computer from the 
    modem cannot be processed by the UART because there is already a 
    character in the UART that has not yet been processed.  This sounds a 
    lot more complicated than it really is.

    There are a several causes of this, and it is usually easily solved.  
    The most common reason is simply a slow UART.  Many older computers 
    with the original 8250 UART chip cannot handle port speeds over 9600, 
    and some poorly designed 8250 boards have difficulty that fast.  The 
    first solution to try is to lower your portspeed value in your .MDM 
    file. 

    The advent of the 16550 UART, with its 16 character buffer, has helped 
    to reduce the occurrence of this problem.  The 16550, by virtue of 
    being a faster UART, can handle port speeds up to 57600, but the real 
    problem solver is the 16 character FIFO (First In, First Out) buffer.  
    Older UARTS, like the 8250 and 16450, can handle only 1 character at a 
    time.  If another character comes in before the UART is done processing 
    the first one, a _UART_Overrun_ will occur, causing an error.  The 
    16550, however, can accept up to 16 characters before having the 
    process them.  This has two distinct advantages.  First, obviously, 
    overruns are less likely to occur.  Second, since the UART has to 
    signal the processor to take the characters less often, transfer speeds 
    tend to increase. 

    Taking advantage of this buffering is as simple as adding a value to 
    the 16550trigger variable in your .MDM file.  Acceptable values are 1 
    (which will cause the 16550 to operate as any other UART), 4, 8, and 
    14.  This value specifies the number of characters that the UART will 
    store before signaling the processor (with an interrupt) to process the 
    characters.  We recommend a setting of 8.  You can also specify the 
    keyword "disable" to turn this feature off.



8.3      Using a Disk Cache

    An often asked question is,  "How can I get UUXQT.EXE to process my 
    mail and news faster?  I've got TONS of news, and it takes a long 
    time!"  Keep in mind the volume of traffic that you're processing.  
    With a large news feed, there is quite a bit of processing going on: 
    decompressing, splitting up articles, determining the newsgroups to 
    place them in, updating incoming information, copying the news article 
    into the proper directory, and cleaning up after the processing.

    There are two things you can do, besides spending another $2000.  We 
    have found that a disk cache works wonders for the processing time of 
    UUXQT.  With the amount of disk I/O that UUXQT performs, a 2-meg disk 
    cache can avoid a large number of disk accesses and group them into a 
    single large write operation.

    The second suggestion is to create a ramdisk and point your temporary 
    directory at it.  This can have a very beneficial effect upon speed.

    WARNING: Disk caches and ram disks are potentially dangerous!  A power 
    outage with data on a ram disk or during a cached operation can result 
    in data loss and corruption of your Usenet and Internet Mail traffic.  
    If you are going to increase your speed through a disk cache or ram 
    disk, we strongly recommend some kind of UPS power backup.  It's a 
    small investment to make to insure that your data is protected.



8.4      Loss of Data Due to Disk Writes

    A very annoying "feature" of PC hardware is the interrupt shutoff 
    during disk writes.  This has the unwanted effect of preventing the 
    UART from signaling the processor that a character has come in.  On 
    slower machines, this interrupt shutoff time can easily be longer than 
    a complete character cycle, and often can prevent 2 or more characters 
    from being seen.  This problem is easy to identify: if you notice that 
    you get "UART Overrun" errors, and a "Checksum Error" immediately 
    following, take a look at your hard disk activity light.  If you see it 
    flash at the same time as these errors, you can confirm that this is 
    your problem.

    The solution is more of a work around than a fix, as there is nothing 
    that can be done about the hardware.  There are, however, a few things 
    that can help reduce the problem.  First, slow down the portspeed.  If 
    you are connecting at 9600 to your host, there is no reason to have 
    your portspeed variable (in your .MDM file) set to 38400!  Try 19200, 
    or even 9600.  In most cases, if your portspeed was set too high, this 
    will eliminate the problem altogether.  If it wasn't set too high, or 
    lowering it has not solved the problem, you may want to increase your 
    disk buffer.  

    The disk buffer is the amount of data that will be stored before a 
    write to disk is made.  By default, MSDOS buffers very little data.  
    UUCICO has the option to set its own disk buffer, and store up to 32K 
    of data before writing to disk.  If most of your transferred files are 
    less than 32K in size, you'll never notice this problem, as there is no 
    modem traffic between files, where the disk write would then occur (the 
    buffer is flushed after each file).  In the worst case, the buffer will 
    flush much less often with a large buffer.  The variable "diskbuffer" 
    is found in the .MDM file.  Note that this variable takes a value in 
    hex (base 16), and the "0x" that is commonly found in front of a hex 
    number is optional.  It's recommended to keep it in, however, to remind 
    you that the number is, in fact hex.  A value of 0x4000, for example, 
    is a 16K buffer. 0x8000, the maximum value, is a 32K buffer.


8.5      Alternate Drivers for UUCICO.EXE

    UUCICO has the option of using its own internal communication drivers, 
    or accessing any FOSSIL-compliant drivers you may have loaded.  The 
    "driver" variable in your .MDM file determines this.  The two valid 
    options are "internal" and "fossil".  The default is to use the 
    internal driver.


8.6      What About Memory Requirements?

    In older versions of UUPlus Utilities (prior to 1.50), the compression 
    utilities were imbedded into the utilities that used them (UUXQT.EXE, 
    BATCHER.EXE, etc.) and required quite a bit of memory.  Decompression, 
    for example, could require up to 610K of free memory to run.  This, 
    being unacceptable to most users, has been changed in version 1.52.  
    COMP.EXE and DECOMP.EXE are now called as external programs from the 
    utilities that need them.  UUPlus Utilities should run fine on a system 
    with only 512K memory.



8.7      How Can I Get UUCICO To Retry If My Host Is Busy?

    UUCICO has the ability to schedule retries in the case of a busy host, 
    a failed connection, or an inability to dial for various reasons.  In 
    your systems file, you need the lines:

         configure  retries 3
         configure  retrytime 30,60,90

    This will instruct UUCICO to retry the system for which the configure 
    pertains up to 3 times before exiting.  After each call, UUCICO will 
    pause the amount of seconds in the retrytime value before trying again.  
    In the above example, UUCICO will make a total of 4 calls (the initial 
    call as well as 3 retries).  After the initial call, it will pause for 
    30 seconds before trying again, 60 seconds after the first retry, and 
    90 seconds after the second retry.  After the third retry, it will give 
    up and exit.

    You may configure up to 10 retries.  If you have less retrytime 
    arguments than the number of retries that you specified, the last value 
    will be repeated.  So, if your configure lines look like:

         configure retries 8
         configure retrytime 30,60,90,120

    then UUCICO will then make a total of 9 calls before giving up, and 
    after the third retry, and for all subsequent retries, it will wait 120 
    seconds each time before trying again.

    If UUCICO gets through and the protocol is started, there will be no 
    further retries.



**********************************************************************
                        INFORMATION and ERROR MESSAGES

                                  Section 9.0


    Information and Error Messages ........................ 9.0
         Startup Messages ................................. 9.1
         Connection Messages .............................. 9.2
         Negotiation Phase Messages ....................... 9.2.1
         Transfer Messages ................................ 9.3
         Control Phase Messages ........................... 9.3.1
         File control Phase ............................... 9.3.2
         Transfer Phase Messages .......................... 9.3.3
         Other messages ................................... 9.4



9.0      Information and Error Messages

    UUCICO, the UUCP protocol transfer engine, can report some confusing 
    messages.  The following is a list of some of the more important 
    messages their meanings, and the solutions.



9.1      Startup Messages

    These messages indicate a problem starting up UUCICO. 


    No modem config file specified.

         The "Chat Script" in the base\lib\uucp\SYSTEMS file is bad or 
         missing.  See the SYSTEMS File section of the manual.


    Could not open modem config file.

         Make sure the proper modem configuration file is in the \base\lib\ 
         modem\directory  and that it matches the modem file in the chat 
         script.  If you are not running UUPlus Utilities from the base 
         directory, be sure that you have the variable "SET 
         UUPLUS=[basedir]" in your AUTOEXEC.BAT file.


    Illegal IRQ specified

         Make  sure  that  the  proper  irq  for the com  port  is 
         specified in the modem configuration file.


    No UART detected
    Unable to classify UART, or no UART present
    Unknown com port type

         UUCICO was not able to detect the specified com port or UART.  

         Check your computers hardware settings.


    Initialization Error

         An error was encountered while UUCICO was trying to initialize the 
         modem.  Check the modem and the .MDM file.


    Error initializing modem   

         Check the "init" line in the .MDM file for valid commands.


    Please insure that CD does NOT track DTR.

         This can usually be set with the &C1 command to your modem in the 
         INIT string.

         Quite a few modems are shipped with CD tracking DTR as the 
         default.  This means that CD will be high if DTR is high.  Since 
         DTR is raised when UUCICO initializes the modem, UUCICO would then 
         think that it is immediately connected.  UUCICO, then, checks to 
         make sure that they do not track by raising, lowering, and raising 
         DTR again, and checking to see if CD did the same.  If so, you 
         will get this message.  

         AT&C1 is almost always the command to have your modem disengage 
         the CD/DTR tracking.


    Bad speed value in systems file

         This indicates that the speed value in the chat script line in the 
         systems file was not a valid value (perhaps a negative number, or 
         some huge number).


    g Init: heap empty, aborting
    g Init: heap corrupt, aborting
    g Init: heap error, aborting

         These are messages that might come up while initializing the g 
         protocol driver. The indicate errors with UUCICO.  Try re-running 
         UUCICO.  If the problem persists, reboot your computer.


    The following are memory allocation errors during the allocation of the 
    buffers for UUCICO.  They indicate a severe shortage of memory.  Try 
    freeing up some memory by removing TSRs or with a memory manager.

    Memory Allocation Error, GPOLLVIEW
    Memory Allocation Error, GPROTOCOL
    OpenDriver: MEMORY ALLOCATION ERROR, outPacket
    OpenDriver: MEMORY ALLOCATION ERROR, outPacket
    OpenDriver: MEMORY ALLOCATION ERROR, rawData
    OpenDriver: MEMORY ALLOCATION ERROR, outbuf
    OpenDriver: MEMORY ALLOCATION ERROR, inbuf



9.2      Connection Messages

    The following are responses that might be seen during the connection 
    attempt to your host provider immediately after dialing.  They are 
    conditions the modem may report.


    No Carrier

         The "No Carrier" messages indicates that the connection between 
         your computer and your host was terminated.  This can be caused by 
         a number of things, and usually can be solved by re-polling the 
         site.  If the "No Carrier" messages persists, you host may be 
         down for servicing.


    Modem Error

         The modem reported an error.  Re-poll the site.


    No Dialtone

         Check to see if your modem is connected to the phone line.


    Called number is busy.

         If RETRIES and RETRYTIMES are set then UUCICO  will redial when 
         specified.


    No Answer

         Host provider is off line or you have a wrong number.


    Called number is answered with voice.

         "Oops..."  Check  the number in the chat script in the systems 
         file.


    Call timeout

         The call timed out waiting for data.  You may want to increase the 
         timeout periods.


    Unknown modem result

         UUCICO received an unknown result code from the modem.  This can 
         be caused by several things.  Check the INIT line in the .MDM 
         file.  If this is Ok, then try resetting the modem by turning it 
         on and off.  If you have an internal modem, you may have to 
         completely shut off your system to do this.  If "FCON" appears on 
         the screen or in the debug file, you may have run your fax program 
         before running UUCICO, and your modem was set to fax mode.  There 
         could also be a problem with another program trying to use the com 
         port at the same time.



9.2.1    Negotiation Phase Messages.

    STARTUP: rmsg timeout (M1)
    STARTUP: rmsg timeout (M2)
    STARTUP: rmsg timeout (M3)
    STARTUP: rmsg timeout (S1)
    STARTUP: rmsg timeout (S2)

         UUPlus has timed out while waiting for data from the remote site. 
         The code in parenthesis designates where in the process the 
         timeout occurred.  M codes are for master and S codes are for 
         slave mode.


    STARTUP: Shere error [data]

         The Shere error indicates that UUCICO had a problem parsing the 
         Shere message.  "Shere" is the message that the remote sends to 
         identify itself.  UUPlus did not receive an "=" as the 6th 
         character in the Shere message expected at this point.  On some 
         older systems the host name is not returned with the Shere 
         message.  Run UUCICO with the -h (ignoreHost) option. The actual 
         message received is displayed.  

         
    STARTUP: host name error [data]

         The host name that the remote site identified itself with 
         in the Shere message did not match the host name that you 
         specified with the -s parameter on the UUCICO command line.


    STARTUP: No U or No common protocol [data]
    STARTUP: No P or No common protocol [data]

         No protocol message was received, or no common protocols could be 
         found.  The data sent from the remote is displayed.


    STARTUP: M2 not OK, got [data]

         No "ROK" message was received.  The data sent from the remote is 
         displayed.


    SETPROTO: Could not find protocol

         The protocol agreed upon could not be found in the protocol table. 

         Since UUPlus only supports "g" at this time, this message should
         never appear.


    RMSG: flushing for sync
    RMSG: timeout in sync phase
    RMSG: timeout in data phase

         The "RMSG" is the section of UUCICO responsible for communicating 
         with the remote site before the actual protocol begins.  These 
         timeout messages indicate that the remote has not yet sent either 
         a sync or the data expected.  It could mean a bad connection, or 
         simply a slow remote.  The "flushing for sync" means simply that 
         the system is letting data go by until it syncs up with the 
         remote.


    Startup: Invalid R Message

         The "R Message" is the reply from the remote telling you that 
         everything is OK, and we can start the protocol.  This error 
         indicates that UUCICO had a problem parsing the R Message.


    waiting for shere
    waiting for ROK message

         These 2 messages indicate that UUCICO is simply waiting for the 
         appropriate messages from the remote.


    waiting for protocol

         UUCICO is waiting for the remote site to identify the protocols it 
         speaks.  This can take awhile on slow or busy systems.


    Startup: No Common Protocol

         This will almost assuredly never come up.  It indicates that 
         UUCICO and the remote site could not find a protocol in common.  
         Since all UUCP packages speak 'g' protocol, without exception, 
         this should never happen.


    ROK: Taylor UUCP limiting feature enabled
    ROK: Remote ULIMIT set to [amount] bytes

         These messages indicate features that are enabled during startup


    Warning: INITA & INITC windows don't match

         During startup, the INITA and INITC packets should contain the 
         same value for the number of packet windows to use.  This warning 
         simply means that they didn't match.  UUCICO will use the value in 
         INITC.


    Illegal packet size, use 64-4096, not single-digits.

         During startup, the packet size you requested (or the default, if 
         you do not specifically request a packet size) is verified.  If it 
         is not, you will get this message.



9.3      Transfer Messages


9.3.1    Control Phase Messages

    SBREAK: error sending [H] message (sndpkt)
    SBREAK: error receiving [H] reply (getpkt)

         An "H" message was expected and was never seen.

    SEND: malformed command line [data]

         A badly formed command line was found.  The actual command line is 
         displayed.

    SEND: invalid request: [data]

         The remote has sent an invalid request.  The actual request is 
         displayed.

    SDF: error sending request
    SDF: error receiving reply

         An error occurred sending or receiving a command to/from the remote.

    SDF: did not get 'Y' got [data]

         UUPlus did not receive permission to complete the request.  The 
         actual reply is displayed.


9.3.2    File control Phase:

    RECEIVE: [error] closing [filename]
    RECEIVE: Error writing data to [filename]
    SEND: [error] opening workfile [filename]
    SEND: error opening command file [filename]

         A DOS error occurred while operating on the file "filename"



9.3.3    Transfer Phase Messages

    SDF: sendpkt failure
    SCHKDIR: sendpkt failure
    RECEIVE: sendpkt failure (SY)
    RECEIVE: sendpkt failure (CY)

         The packet sending mechanism failed.


    RECEIVE: getpkt failure
    RECEIVE: getpkt failure

         The packet receiving mechanism failed.  Getpkt failure is a general 
         catch-all error message meaning that there was a problem in the
packet 
         transfer mechanism.  The above errors are usually caused by phone 
         noise or an error on the remote side.  A simple solution is to wait a

         short time and then re-poll the site.


    As the transfer runs, there are a few conditions that can cause an 
    incoming packet to be rejected.  The above messages indicate that one 
    of these conditions has occurred. The most common cause for these 
    errors is line noise.


    Packet Error: Header deficient

         Indicates that there were not enough characters received to 
         construct a valid header. 


    Packet Error: Bad header xor

         Means that the header's checksum (a simple xor) failed, indicating 
         a garbled transmission. 


    Packet Error: Packet data deficient

         Means that not enough characters were received to construct a full 
         packet.  


    Packet Error: Checksum error

         Means that the packet's checksum did not match the calculated 
         checksum, and the packet must be rejected. 


    Driver: Data out of sequence: got [value] expected [value]
    Driver: data out of window: got [value] window ([value] - [value])

         These are common errors after a checksum error has occurred.  They 
         mean that the packets received were out of order, or out of the 
         expected window.  If a packet is requested to be resent, there 
         will usually be up to 6 packets already "in the pipe" that are no 
         longer valid.  These messages indicate that they came in.


    FATAL ERROR: incoming packet larger than buffer

         This means that the remote site sent a packet larger than they 
         said they would (and hence, larger than the buffer that we 
         allocated)


*************************************************************************
9.4      Other messages

    The following are other messages that UUCICO will report.

    Remote site does not have an entry for you! Contact the administrator
    of [sitename] to solve this problem.

         This message means that your host provider has not yet set up your 
         UUCP account.  Give them a call.


    Remote site thinks that it is already talking to us. Perhaps it is.

         UUCICO will not talk to a site that thinks it is already talking 
         to you.  This could be caused by the host provider failing to 
         disconnect when you have, or you might be running a transfer on 
         another machine.  You may only have one UUCICO running at any time 
         to the same provider.


    Remote site will call back

         This indicates that UUCICO was told by your host provider that it 
         would rather call you back.  Since UUCICO does not support auto- 
         answer of calls, you should contact your host provider and inform 
         them that you are getting this message.


    These 2 messages should be self-explanatory:

    Remote site reports back sequence number.  Since we don't support 
    sequencing, please inform the administrator of [sitename] to turn off 
    sequencing

    You appear to be using the wrong login name for this UUCP account 
    Contact the administrator of [sitename] and tell them that you are 
    receiving RLOGIN messages on your UUCP feed


*************************************************************************
10.0     MISCELLANEOUS INFORMATION.


10.1     RFC-822  TIME and DATE Specification.

    The following information is taken directly from:

                                  RFC #  822
                          STANDARD FOR THE FORMAT OF
                          ARPA INTERNET TEXT MESSAGES
                                August 13, 1982
                                  Revised by
                               David H. Crocker
                        Dept. of Electrical Engineering
                   University of Delaware, Newark, DE  19711
                        Network:  DCrocker @ UDel-Relay


     (5.)  DATE AND TIME SPECIFICATION

     (5.1.)  SYNTAX

     date-time   =  [ day "," ] date time        ; dd mm yy
                                                 ;  hh:mm:ss zzz

     day         =  "Mon"  / "Tue" /  "Wed"  / "Thu"
                 /  "Fri"  / "Sat" /  "Sun"

     date        =  1*2DIGIT month 2DIGIT        ; day month year
                                                 ;  e.g. 20 Jun 82

     month       =  "Jan"  /  "Feb" /  "Mar"  /  "Apr"
                 /  "May"  /  "Jun" /  "Jul"  /  "Aug"
                 /  "Sep"  /  "Oct" /  "Nov"  /  "Dec"

     time        =  hour zone                    ; ANSI and Military

     hour        =  2DIGIT ":" 2DIGIT [":" 2DIGIT]
                                                 ; 00:00:00 - 23:59:59

     zone        =  "UT"  / "GMT"                ; Universal Time
                                                 ; North American : UT
                 /  "EST" / "EDT"                ;  Eastern:  - 5/ - 4
                 /  "CST" / "CDT"                ;  Central:  - 6/ - 5
                 /  "MST" / "MDT"                ;  Mountain: - 7/ - 6
                 /  "PST" / "PDT"                ;  Pacific:  - 8/ - 7
                 /  1ALPHA                       ; Military: Z = UT;
                                                 ;  A:-1; (J not used)
                                                 ;  M:-12; N:+1; Y:+12
                 / ( ("+" / "-") 4DIGIT )        ; Local differential
                                                 ;  hours+min. (HHMM)

     (5.2.)  SEMANTICS

          If included, day-of-week must be the day implied by the date
     specification.

          Time zone may be indicated in several ways.  "UT" is Univer-
     sal  Time  (formerly called "Greenwich Mean Time"); "GMT" is per-
     mitted as a reference to Universal Time.  The  military  standard
     uses  a  single  character for each zone.  "Z" is Universal Time.
     "A" indicates one hour earlier, and "M" indicates 12  hours  ear-
     lier;  "N"  is  one  hour  later, and "Y" is 12 hours later.  The
     letter "J" is not used.  The other remaining two forms are  taken
     from ANSI standard X3.51-1975.  One allows explicit indication of
     the amount of offset from UT; the other uses  common  3-character
     strings for indicating time zones in North America.



10.2     TIME ZONES


    The following is a list of valid Time Zones.

        GMT  or  UT 
        EST   /   EDT   
        CST   /   CDT        
        MST   /   MDT
        PST   /   PDT     
        IST
        SST

        +0100    +0200    +0300    +0400    +0500    +0600    +0700
        +0800    +0900    +1000    +1100    +1200    +1300    +1400

        -0100    -0200    -0300    -0400    -0500    -0600    -0700     
        -0800    -0900    -1000    -1100    -1200    -1300    -1400    

    **********************************************************************
--
*----------------------------------------------------------------------------*
|John Bonnett  -  UUPlus Development  -  P.O.Box 6991  -  Los Osos, CA. 93402|
|Internet: jhb@uuplus.com   -   Voice: (805) 534-1425  -  Fax: (805) 534-9502|
*----------------------------------------------------------------------------*





